# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "sampler4xi.py">
#<abstract4xi abstract = "sampler management"/>
#<refer4xi reference = "Samplers"/>
#<verify4xi verification = "10" target = "sampler4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API                
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Sampler4Xi',                         # NACK 5.31  p76 
            
            'create2sampler4xi',                  # NACK 5.31  p76           

            'get2samplerinfo4xi',                 # NACK 5.3.6 p97        

            'retain2sampler4xi',                  # NACK 5.4.1 p99
            'release2sampler4xi',                 # NACK 5.4.1 p99

            'set2samplercallback4xi',             # NACK
            'set2sampler4xi',                     # NACK          

            'trace2sampler4xi',                   # NACK 
           
          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi


# -------------------------------------------------------------------------------------------------
# Image modules of devices                           
# -------------------------------------------------------------------------------------------------
from apu2sampler4xi import APU2Sampler4Xi                                                             
from bpu2sampler4xi import BPU2Sampler4Xi
from cpu2sampler4xi import CPU2Sampler4Xi
from dpu2sampler4xi import DPU2Sampler4Xi
from epu2sampler4xi import EPU2Sampler4Xi
from fpu2sampler4xi import FPU2Sampler4Xi
from gpu2sampler4xi import GPU2Sampler4Xi
from hpu2sampler4xi import HPU2Sampler4Xi
from ipu2sampler4xi import IPU2Sampler4Xi
from jpu2sampler4xi import JPU2Sampler4Xi
from kpu2sampler4xi import KPU2Sampler4Xi
from lpu2sampler4xi import LPU2Sampler4Xi
from mpu2sampler4xi import MPU2Sampler4Xi
from npu2sampler4xi import NPU2Sampler4Xi
from opu2sampler4xi import OPU2Sampler4Xi
from ppu2sampler4xi import PPU2Sampler4Xi
from qpu2sampler4xi import QPU2Sampler4Xi
from rpu2sampler4xi import RPU2Sampler4Xi
from spu2sampler4xi import SPU2Sampler4Xi
from tpu2sampler4xi import TPU2Sampler4Xi
from upu2sampler4xi import UPU2Sampler4Xi
from vpu2sampler4xi import VPU2Sampler4Xi
from xpu2sampler4xi import XPU2Sampler4Xi
from wpu2sampler4xi import WPU2Sampler4Xi
from ypu2sampler4xi import YPU2Sampler4Xi
from zpu2sampler4xi import ZPU2Sampler4Xi

from apu2sampler4xi import create2sampler4apu                                                            
from bpu2sampler4xi import create2sampler4bpu
from cpu2sampler4xi import create2sampler4cpu
from dpu2sampler4xi import create2sampler4dpu
from epu2sampler4xi import create2sampler4epu
from fpu2sampler4xi import create2sampler4fpu
from gpu2sampler4xi import create2sampler4gpu
from hpu2sampler4xi import create2sampler4hpu
from ipu2sampler4xi import create2sampler4ipu
from jpu2sampler4xi import create2sampler4jpu
from kpu2sampler4xi import create2sampler4kpu
from lpu2sampler4xi import create2sampler4lpu
from mpu2sampler4xi import create2sampler4mpu
from npu2sampler4xi import create2sampler4npu
from opu2sampler4xi import create2sampler4opu
from ppu2sampler4xi import create2sampler4ppu
from qpu2sampler4xi import create2sampler4qpu
from rpu2sampler4xi import create2sampler4rpu
from spu2sampler4xi import create2sampler4spu
from tpu2sampler4xi import create2sampler4tpu
from upu2sampler4xi import create2sampler4upu
from vpu2sampler4xi import create2sampler4vpu
from xpu2sampler4xi import create2sampler4xpu
from wpu2sampler4xi import create2sampler4wpu
from ypu2sampler4xi import create2sampler4ypu
from zpu2sampler4xi import create2sampler4zpu

from apu2sampler4xi import get2samplerinfo4apu                                                            
from bpu2sampler4xi import get2samplerinfo4bpu
from cpu2sampler4xi import get2samplerinfo4cpu
from dpu2sampler4xi import get2samplerinfo4dpu
from epu2sampler4xi import get2samplerinfo4epu
from fpu2sampler4xi import get2samplerinfo4fpu
from gpu2sampler4xi import get2samplerinfo4gpu
from hpu2sampler4xi import get2samplerinfo4hpu
from ipu2sampler4xi import get2samplerinfo4ipu
from jpu2sampler4xi import get2samplerinfo4jpu
from kpu2sampler4xi import get2samplerinfo4kpu
from lpu2sampler4xi import get2samplerinfo4lpu
from mpu2sampler4xi import get2samplerinfo4mpu
from npu2sampler4xi import get2samplerinfo4npu
from opu2sampler4xi import get2samplerinfo4opu
from ppu2sampler4xi import get2samplerinfo4ppu
from qpu2sampler4xi import get2samplerinfo4qpu
from rpu2sampler4xi import get2samplerinfo4rpu
from spu2sampler4xi import get2samplerinfo4spu
from tpu2sampler4xi import get2samplerinfo4tpu
from upu2sampler4xi import get2samplerinfo4upu
from vpu2sampler4xi import get2samplerinfo4vpu
from xpu2sampler4xi import get2samplerinfo4xpu
from wpu2sampler4xi import get2samplerinfo4wpu
from ypu2sampler4xi import get2samplerinfo4ypu
from zpu2sampler4xi import get2samplerinfo4zpu
from apu2sampler4xi import retain2sampler4apu                                                            
from bpu2sampler4xi import retain2sampler4bpu
from cpu2sampler4xi import retain2sampler4cpu
from dpu2sampler4xi import retain2sampler4dpu
from epu2sampler4xi import retain2sampler4epu
from fpu2sampler4xi import retain2sampler4fpu
from gpu2sampler4xi import retain2sampler4gpu
from hpu2sampler4xi import retain2sampler4hpu
from ipu2sampler4xi import retain2sampler4ipu
from jpu2sampler4xi import retain2sampler4jpu
from kpu2sampler4xi import retain2sampler4kpu
from lpu2sampler4xi import retain2sampler4lpu
from mpu2sampler4xi import retain2sampler4mpu
from npu2sampler4xi import retain2sampler4npu
from opu2sampler4xi import retain2sampler4opu
from ppu2sampler4xi import retain2sampler4ppu
from qpu2sampler4xi import retain2sampler4qpu
from rpu2sampler4xi import retain2sampler4rpu
from spu2sampler4xi import retain2sampler4spu
from tpu2sampler4xi import retain2sampler4tpu
from upu2sampler4xi import retain2sampler4upu
from vpu2sampler4xi import retain2sampler4vpu
from xpu2sampler4xi import retain2sampler4xpu
from wpu2sampler4xi import retain2sampler4wpu
from ypu2sampler4xi import retain2sampler4ypu
from zpu2sampler4xi import retain2sampler4zpu

from apu2sampler4xi import release2sampler4apu                                                            
from bpu2sampler4xi import release2sampler4bpu
from cpu2sampler4xi import release2sampler4cpu
from dpu2sampler4xi import release2sampler4dpu
from epu2sampler4xi import release2sampler4epu
from fpu2sampler4xi import release2sampler4fpu
from gpu2sampler4xi import release2sampler4gpu
from hpu2sampler4xi import release2sampler4hpu
from ipu2sampler4xi import release2sampler4ipu
from jpu2sampler4xi import release2sampler4jpu
from kpu2sampler4xi import release2sampler4kpu
from lpu2sampler4xi import release2sampler4lpu
from mpu2sampler4xi import release2sampler4mpu
from npu2sampler4xi import release2sampler4npu
from opu2sampler4xi import release2sampler4opu
from ppu2sampler4xi import release2sampler4ppu
from qpu2sampler4xi import release2sampler4qpu
from rpu2sampler4xi import release2sampler4rpu
from spu2sampler4xi import release2sampler4spu
from tpu2sampler4xi import release2sampler4tpu
from upu2sampler4xi import release2sampler4upu
from vpu2sampler4xi import release2sampler4vpu
from xpu2sampler4xi import release2sampler4xpu
from wpu2sampler4xi import release2sampler4wpu
from ypu2sampler4xi import release2sampler4ypu
from zpu2sampler4xi import release2sampler4zpu

from apu2sampler4xi import set2samplercallback4apu                                                            
from bpu2sampler4xi import set2samplercallback4bpu
from cpu2sampler4xi import set2samplercallback4cpu
from dpu2sampler4xi import set2samplercallback4dpu
from epu2sampler4xi import set2samplercallback4epu
from fpu2sampler4xi import set2samplercallback4fpu
from gpu2sampler4xi import set2samplercallback4gpu
from hpu2sampler4xi import set2samplercallback4hpu
from ipu2sampler4xi import set2samplercallback4ipu
from jpu2sampler4xi import set2samplercallback4jpu
from kpu2sampler4xi import set2samplercallback4kpu
from lpu2sampler4xi import set2samplercallback4lpu
from mpu2sampler4xi import set2samplercallback4mpu
from npu2sampler4xi import set2samplercallback4npu
from opu2sampler4xi import set2samplercallback4opu
from ppu2sampler4xi import set2samplercallback4ppu
from qpu2sampler4xi import set2samplercallback4qpu
from rpu2sampler4xi import set2samplercallback4rpu
from spu2sampler4xi import set2samplercallback4spu
from tpu2sampler4xi import set2samplercallback4tpu
from upu2sampler4xi import set2samplercallback4upu
from vpu2sampler4xi import set2samplercallback4vpu
from xpu2sampler4xi import set2samplercallback4xpu
from wpu2sampler4xi import set2samplercallback4wpu
from ypu2sampler4xi import set2samplercallback4ypu
from zpu2sampler4xi import set2samplercallback4zpu

from apu2sampler4xi import set2sampler4apu                                                            
from bpu2sampler4xi import set2sampler4bpu
from cpu2sampler4xi import set2sampler4cpu
from dpu2sampler4xi import set2sampler4dpu
from epu2sampler4xi import set2sampler4epu
from fpu2sampler4xi import set2sampler4fpu
from gpu2sampler4xi import set2sampler4gpu
from hpu2sampler4xi import set2sampler4hpu
from ipu2sampler4xi import set2sampler4ipu
from jpu2sampler4xi import set2sampler4jpu
from kpu2sampler4xi import set2sampler4kpu
from lpu2sampler4xi import set2sampler4lpu
from mpu2sampler4xi import set2sampler4mpu
from npu2sampler4xi import set2sampler4npu
from opu2sampler4xi import set2sampler4opu
from ppu2sampler4xi import set2sampler4ppu
from qpu2sampler4xi import set2sampler4qpu
from rpu2sampler4xi import set2sampler4rpu
from spu2sampler4xi import set2sampler4spu
from tpu2sampler4xi import set2sampler4tpu
from upu2sampler4xi import set2sampler4upu
from vpu2sampler4xi import set2sampler4vpu
from xpu2sampler4xi import set2sampler4xpu
from wpu2sampler4xi import set2sampler4wpu
from ypu2sampler4xi import set2sampler4ypu
from zpu2sampler4xi import set2sampler4zpu

from apu2sampler4xi import trace2sampler4apu                                                            
from bpu2sampler4xi import trace2sampler4bpu
from cpu2sampler4xi import trace2sampler4cpu
from dpu2sampler4xi import trace2sampler4dpu
from epu2sampler4xi import trace2sampler4epu
from fpu2sampler4xi import trace2sampler4fpu
from gpu2sampler4xi import trace2sampler4gpu
from hpu2sampler4xi import trace2sampler4hpu
from ipu2sampler4xi import trace2sampler4ipu
from jpu2sampler4xi import trace2sampler4jpu
from kpu2sampler4xi import trace2sampler4kpu
from lpu2sampler4xi import trace2sampler4lpu
from mpu2sampler4xi import trace2sampler4mpu
from npu2sampler4xi import trace2sampler4npu
from opu2sampler4xi import trace2sampler4opu
from ppu2sampler4xi import trace2sampler4ppu
from qpu2sampler4xi import trace2sampler4qpu
from rpu2sampler4xi import trace2sampler4rpu
from spu2sampler4xi import trace2sampler4spu
from tpu2sampler4xi import trace2sampler4tpu
from upu2sampler4xi import trace2sampler4upu
from vpu2sampler4xi import trace2sampler4vpu
from xpu2sampler4xi import trace2sampler4xpu
from wpu2sampler4xi import trace2sampler4wpu
from ypu2sampler4xi import trace2sampler4ypu
from zpu2sampler4xi import trace2sampler4zpu

# -------------------------------------------------------------------------------------------------
# Buffer module                           
# -------------------------------------------------------------------------------------------------
from buffer4xi import Buffer4Xi
from buffer4xi import create2buffer4xi
from buffer4xi import create2subbuffer4xi
from buffer4xi import get2bufferinfo4xi
from buffer4xi import release2buffer4xi
from buffer4xi import retain2buffer4xi
from buffer4xi import set2buffer4xi


# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from commandqueue4xi import CommandQueue4Xi
from commandqueue4xi import create2commandqueue4xi 
from commandqueue4xi import flush2commandqueue4xi
from commandqueue4xi import finish2commandqueue4xi
from commandqueue4xi import get2commandqueueinfo4xi
from commandqueue4xi import release2commandqueue4xi
from commandqueue4xi import retain2commandqueue4xi
from commandqueue4xi import set2commandqueue4xi


# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi 
from context4xi import create2context4xi
from context4xi import get2context4xi
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi
from device4xi import init2device4xi 
from device4xi import set2device4xi
from device4xi import get2device4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from event4xi import Event4Xi


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global sampler4xi                                                      # 2D-SAMPLERS

global samplertrace4xi                                                 # TRACE

global info2sampler4xi                                                 # SAMPLER INFORMATION

global platform2xi                                                     # PLATFORM
global device2xi                                                       # DEVICE
global context2xi                                                      # CONTEXT

        
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
sampler4xi = {}                                                      # 2D-SAMPLERS
samplertrace4xi = {}                                                 # TRACE
info2sampler4xi = {}                                                 # SAMPLER INFORMATION

platform2xi = {}                                                     # PLATFORM
device2xi   = {}                                                     # DEVICE
context2xi  = {}                                                     # CONTEXT

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2sampler4xi" usage = "  
#
#   print('(Step 15A/25) OF SAMPLER2D4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
#   try:                               
#       task4trace2sampler  = {}
#       for key2pu in keys2pu:
#           task4trace2sampler[key2pu]  = {}
#       response4trace2sampler = trace2sampler4xi(task4trace2sampler)  
#       key2response = response4trace2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4trace2sampler[key2response] )
#           # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4apu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4apu', 'METHOD': 'trace2sampler4apu'}
#           # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4gpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4gpu', 'METHOD': 'trace2sampler4gpu'}
#           # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4xpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4xpu', 'METHOD': 'trace2sampler4xpu'}
#           # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4zpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4zpu', 'METHOD': 'trace2sampler4zpu'}                                                                                                  
#   except:
#       print('(Step 15Z1/25) OF SAMPLER2D4XI5TEST *** FAILED TO TRACE XI: ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def trace2sampler4xi(task4trace2xi=None):  

    '''
    creates callback to sampler4xi
    '''

    global samplertrace4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class2print = "trace2sampler4xi" 
    method2print = "trace2sampler4xi"

    message2print = "{(Step 1A/33) started" + "; trace2sampler4xi-started: " + str(trace2sampler4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function trace2sampler4xi at 0x0000000003AF0348> 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2xi-to-trace2sampler4xi: " + str(task4trace2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    samplertrace4xi = {}                                                                                             # INITIALIZES TO EMPTY DICTIONARY
      
      
    if task4trace2xi is None:
        keys2task = None    
    else:
        try:
            keys2task = task4trace2xi.keys()
        except:
            keys2task = None   
    if debug is True:
       print("{(Step 1C/33) of trace2sampler4xi - keys2task: ", sorted(keys2task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2task:
            message2print = "{(Step A/33) passing" + "; task-passing-to-trace2sampler4apu: " + str(task4trace2xi['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            samplertrace4xi ['APU']  = trace2sampler4apu()                                                      
             
            message2print = "{(Step A1/33) set" + "; apu-sampler-trace-set-by-trace2sampler4apu to: " + str(samplertrace4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of trace2sampler4xi - set trace4xi of APU sampler to: ", samplertrace4xi ['APU'])
            
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-trace2sampler4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2task:
            message2print = "{(Step B/33) passing" + "; task-passing-to-trace2sampler4bpu: " + str(task4trace2xi['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['BPU']  = trace2sampler4bpu()                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-sampler-trace-set-by-trace2sampler4bpu to: " + str(samplertrace4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-trace2sampler4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2task:
            message2print = "{(Step C/33) passing" + "; task-passing-to-trace2sampler4cpu: " + str(task4trace2xi['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['CPU']  = trace2sampler4cpu()                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-sampler-trace-set-by-trace2sampler4cpu to: " + str(samplertrace4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-trace2sampler4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2task:
            message2print = "{(Step D/33) passing" + "; task-passing-to-trace2sampler4dpu: " + str(task4trace2xi['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['DPU']  = trace2sampler4dpu()                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-sampler-trace-set-by-trace2sampler4dpu to: " + str(samplertrace4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-trace2sampler4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2task:
            message2print = "{(Step E/33) passing" + "; task-passing-to-trace2sampler4epu: " + str(task4trace2xi['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['EPU']  = trace2sampler4epu()                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-sampler-trace-set-by-trace2sampler4epu to: " + str(samplertrace4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-trace2sampler4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2task:
            message2print = "{(Step F/33) passing" + "; task-passing-to-trace2sampler4fpu: " + str(task4trace2xi['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['FPU']  = trace2sampler4fpu()                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-sampler-trace-set-by-trace2sampler4fpu to: " + str(samplertrace4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-trace2sampler4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2task:
            message2print = "{(Step G/33) passing" + "; task-passing-to-trace2sampler4gpu: " + str(task4trace2xi['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['GPU']  = trace2sampler4gpu()                                                      # 
         
            message2print = "{(Step G1/33) set" + "; gpu-sampler-trace-set-by-trace2sampler4gpu to: " + str(samplertrace4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-trace2sampler4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2task:
            message2print = "{(Step H/33) passing" + "; task-passing-to-trace2sampler4hpu: " + str(task4trace2xi['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['HPU']  = trace2sampler4hpu()                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-sampler-trace-set-by-trace2sampler4hpu to: " + str(samplertrace4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-trace2sampler4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2task:
            message2print = "{(Step I/33) passing" + "; task-passing-to-trace2sampler4ipu: " + str(task4trace2xi['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['IPU']  = trace2sampler4ipu()                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-sampler-trace-set-by-trace2sampler4ipu to: " + str(samplertrace4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-trace2sampler4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2task:
            message2print = "{(Step J/33) passing" + "; task-passing-to-trace2sampler4jpu: " + str(task4trace2xi['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['JPU']  = trace2sampler4jpu()                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-sampler-trace-set-by-trace2sampler4jpu to: " + str(samplertrace4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-trace2sampler4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2task:
            message2print = "{(Step K/33) passing" + "; task-passing-to-trace2sampler4kpu: " + str(task4trace2xi['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['KPU']  = trace2sampler4kpu()                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-sampler-trace-set-by-trace2sampler4kpu to: " + str(samplertrace4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-trace2sampler4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2task:
            message2print = "{(Step L/33) passing" + "; task-passing-to-trace2sampler4lpu: " + str(task4trace2xi['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['LPU']  = trace2sampler4lpu()                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-sampler-trace-set-by-trace2sampler4lpu to: " + str(samplertrace4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-trace2sampler4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2task:
            message2print = "{(Step M/33) passing" + "; task-passing-to-trace2sampler4mpu: " + str(task4trace2xi['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['MPU']  = trace2sampler4mpu()                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-sampler-trace-set-by-trace2sampler4mpu to: " + str(samplertrace4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-trace2sampler4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2task:
            message2print = "{(Step N/33) passing" + "; task-passing-to-trace2sampler4npu: " + str(task4trace2xi['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['NPU']  = trace2sampler4npu()                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-sampler-trace-set-by-trace2sampler4npu to: " + str(samplertrace4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-trace2sampler4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2task:
            message2print = "{(Step O/33) passing" + "; task-passing-to-trace2sampler4opu: " + str(task4trace2xi['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['OPU']  = trace2sampler4opu()                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-sampler-trace-set-by-trace2sampler4opu to: " + str(samplertrace4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-trace2sampler4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2task:
            message2print = "{(Step P/33) passing" + "; task-passing-to-trace2sampler4ppu: " + str(task4trace2xi['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['PPU']  = trace2sampler4ppu()                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-sampler-trace-set-by-trace2sampler4ppu to: " + str(samplertrace4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-trace2sampler4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2task:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-trace2sampler4qpu: " + str(task4trace2xi['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['QPU']  = trace2sampler4qpu()                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-sampler-trace-set-by-trace2sampler4qpu to: " + str(samplertrace4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-trace2sampler4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2task:
            message2print = "{(Step R/33) passing" + "; task-passing-to-trace2sampler4rpu: " + str(task4trace2xi['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['RPU']  = trace2sampler4rpu()                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-sampler-trace-set-by-trace2sampler4rpu to: " + str(samplertrace4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-trace2sampler4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2task:
            message2print = "{(Step S/33) passing" + "; task-passing-to-trace2sampler4spu: " + str(task4trace2xi['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['SPU']  = trace2sampler4spu()                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-sampler-trace-set-by-trace2sampler4spu to: " + str(samplertrace4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-trace2sampler4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2task:
            message2print = "{(Step T/33) passing" + "; task-passing-to-trace2sampler4tpu: " + str(task4trace2xi['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['TPU']  = trace2sampler4tpu()                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-sampler-trace-set-by-trace2sampler4tpu to: " + str(samplertrace4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-trace2sampler4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2task:
            message2print = "{(Step U/33) passing" + "; task-passing-to-trace2sampler4upu: " + str(task4trace2xi['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['UPU']  = trace2sampler4upu()                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-sampler-trace-set-by-trace2sampler4upu to: " + str(samplertrace4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-trace2sampler4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2task:
            message2print = "{(Step V/33) passing" + "; task-passing-to-trace2sampler4vpu: " + str(task4trace2xi['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['VPU']  = trace2sampler4vpu()                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-sampler-trace-set-by-trace2sampler4vpu to: " + str(samplertrace4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-trace2sampler4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2task:
            message2print = "{(Step W/33) passing" + "; task-passing-to-trace2sampler4wpu: " + str(task4trace2xi['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['WPU']  = trace2sampler4wpu()                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-sampler-trace-set-by-trace2sampler4wpu to: " + str(samplertrace4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-trace2sampler4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2task:
            message2print = "{(Step X/33) passing" + "; task-passing-to-trace2sampler4xpu: " + str(task4trace2xi['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['XPU']  = trace2sampler4xpu()                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-sampler-trace-set-by-trace2sampler4xpu to: " + str(samplertrace4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of trace2sampler4xi - set trace4xi of XPU sampler to: ", samplertrace4xi ['XPU'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-trace2sampler4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2task:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-trace2sampler4ypu: " + str(task4trace2xi['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['YPU']  = trace2sampler4ypu()                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-sampler-trace-set-by-trace2sampler4ypu to: " + str(samplertrace4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-trace2sampler4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2task:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-trace2sampler4zpu: " + str(task4trace2xi['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            samplertrace4xi ['ZPU']  = trace2sampler4zpu()                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-sampler-trace-set-by-trace2sampler4zpu to: " + str(samplertrace4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of trace2sampler4xi - set trace4xi of ZPU sampler to: ", samplertrace4xi ['ZPU'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-trace2sampler4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    print("{(Step 33/33) of trace2sampler4xi samplertrace4xi - RETURNING : ") 
    if debug is True:
        for key2task in keys2task:
            print(key2task, samplertrace4xi[key2task])
            # DPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}
            # EPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4epu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4epu', 'METHOD': 'trace2sampler4epu'}
            # BPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4bpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4bpu', 'METHOD': 'trace2sampler4bpu'}
            # CPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4cpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4cpu', 'METHOD': 'trace2sampler4cpu'}
            # VPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4vpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4vpu', 'METHOD': 'trace2sampler4vpu'}
            # RPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4rpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4rpu', 'METHOD': 'trace2sampler4rpu'}
            # WPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4wpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4wpu', 'METHOD': 'trace2sampler4wpu'}
            # SPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4spu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4spu', 'METHOD': 'trace2sampler4spu'}
            # PPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ppu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4ppu', 'METHOD': 'trace2sampler4ppu'}
            # QPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4qpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4qpu', 'METHOD': 'trace2sampler4qpu'}
            # KPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4kpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4kpu', 'METHOD': 'trace2sampler4kpu'}
            # YPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ypu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4ypu', 'METHOD': 'trace2sampler4ypu'}
            # LPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4lpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4lpu', 'METHOD': 'trace2sampler4lpu'}
            # ZPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4zpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4zpu', 'METHOD': 'trace2sampler4zpu'}
            # HPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4hpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4hpu', 'METHOD': 'trace2sampler4hpu'}
            # FPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4fpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4fpu', 'METHOD': 'trace2sampler4fpu'}
            # TPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4tpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4tpu', 'METHOD': 'trace2sampler4tpu'}
            # GPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4gpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4gpu', 'METHOD': 'trace2sampler4gpu'}
            # UPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}
            # XPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4xpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4xpu', 'METHOD': 'trace2sampler4xpu'}
            # OPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4opu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4opu', 'METHOD': 'trace2sampler4opu'}
            # APU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4apu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4apu', 'METHOD': 'trace2sampler4apu'}
            # MPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4mpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4mpu', 'METHOD': 'trace2sampler4mpu'}
            # IPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ipu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4ipu', 'METHOD': 'trace2sampler4ipu'}
            # NPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4npu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4npu', 'METHOD': 'trace2sampler4npu'}
            # JPU {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4jpu-failed {}; time: 02:57:56 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4jpu', 'METHOD': 'trace2sampler4jpu'}    
    message2print = "{(Step 33/33) returning" + "; samplertrace4xi-returning-by-trace2sampler4xi: " + str(samplertrace4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #  
    
    return samplertrace4xi


#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2samplercallback4xi" usage = " 
#
#   print('(Step 14B/700) OF SAMPLER2D4XI5TEST - TRYING TO SET 2D SAMPLER CALLBACK OF XI DEVICE ', time4xi())     
#   try:                               
#       task4callback2sampler  = {}
#       for key2pu in keys2pu:
#           task4callback2sampler[key2pu]  = {}
#       response4setcallback2sampler = set2samplercallback4xi(task4callback2sampler) 
#       key2response = response4setcallback2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4setcallback2sampler[key2response])
#           # APU  :  <function trace2sampler4apu at 0x00000000043F1C48>
#           # ...
#           # ZPU  :  <function trace2sampler4zpu at 0x00000000058610C8>
#                                                                                                     
#   except:
#       print('(Step 14Z2/700) OF SAMPLER2D4XI5TEST *** FAILED TO SET 2D SAMPLER CALLBACK OF XI DEVICE ', time4xi())
#
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2samplercallback4xi(task4set2samplercallback=None):

    '''
    registers callback function to sampler4xi
    '''
    global sampler4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class2print = "set2samplercallback4xi"
    method2print = "set2samplercallback4xi"

    message2print = "{(Step 1A/33) started" + "; set2samplercallback4xi-started: " + str(set2samplercallback4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2samplercallback4xi at 0x0000000003A62848> 
    
    message2print = "{(Step 1B/33) passed" + "; task4samplerset2xi-to-set2samplercallback4xi: " + str(task4set2samplercallback) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
            
    code2ack  = ' '
    code2nack = ' '
    if sampler4xi is None:
        sampler4xi = create2sampler4xi()                                                                            
                                
        message2print = "{(Step 1C/33) set" + "; sampler4xi-set-by-set2samplercallback4xi to: " + str(sampler4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
    
        
    if task4set2samplercallback is None:
        keys2task = None    
    else:
        try:
            keys2task = task4set2samplercallback.keys()
        except:
            keys2task = None   
    if debug is True:
       print("{(Step 1C/33) of set2samplercallback4xi - keys2task: ", sorted(keys2task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2task:
            message2print = "{(Step A/33) passing" + "; task-passing-to-set2samplercallback4apu: " + str(task4set2samplercallback['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            sampler4xi ['APU'] ['CALLBACK'] = set2samplercallback4apu()                                                      # 
             
            message2print = "{(Step A1/33) set" + "; apu-sampler-set-by-set2samplercallback4apu to: " + str(sampler4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of set2samplercallback4xi - set callback4xi of APU sampler to: ", sampler4xi ['APU'] ['CALLBACK'])
            
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2samplercallback4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2task:
            message2print = "{(Step B/33) passing" + "; task-passing-to-set2samplercallback4bpu: " + str(task4set2samplercallback['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['BPU'] ['CALLBACK'] = set2samplercallback4bpu()                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-sampler-set-by-set2samplercallback4bpu to: " + str(sampler4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2samplercallback4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2task:
            message2print = "{(Step C/33) passing" + "; task-passing-to-set2samplercallback4cpu: " + str(task4set2samplercallback['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['CPU'] ['CALLBACK'] = set2samplercallback4cpu()                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-sampler-set-by-set2samplercallback4cpu to: " + str(sampler4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2samplercallback4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2task:
            message2print = "{(Step D/33) passing" + "; task-passing-to-set2samplercallback4dpu: " + str(task4set2samplercallback['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['DPU'] ['CALLBACK'] = set2samplercallback4dpu()                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-sampler-set-by-set2samplercallback4dpu to: " + str(sampler4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2samplercallback4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2task:
            message2print = "{(Step E/33) passing" + "; task-passing-to-set2samplercallback4epu: " + str(task4set2samplercallback['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['EPU'] ['CALLBACK'] = set2samplercallback4epu()                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-sampler-set-by-set2samplercallback4epu to: " + str(sampler4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2samplercallback4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2task:
            message2print = "{(Step F/33) passing" + "; task-passing-to-set2samplercallback4fpu: " + str(task4set2samplercallback['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['FPU'] ['CALLBACK'] = set2samplercallback4fpu()                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-sampler-set-by-set2samplercallback4fpu to: " + str(sampler4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2samplercallback4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2task:
            message2print = "{(Step G/33) passing" + "; task-passing-to-set2samplercallback4gpu: " + str(task4set2samplercallback['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['GPU'] ['CALLBACK'] = set2samplercallback4gpu()                                                      # 
         
            message2print = "{(Step G1/33) set" + "; gpu-sampler-set-by-set2samplercallback4gpu to: " + str(sampler4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2samplercallback4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2task:
            message2print = "{(Step H/33) passing" + "; task-passing-to-set2samplercallback4hpu: " + str(task4set2samplercallback['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['HPU'] ['CALLBACK'] = set2samplercallback4hpu()                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-sampler-set-by-set2samplercallback4hpu to: " + str(sampler4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2samplercallback4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2task:
            message2print = "{(Step I/33) passing" + "; task-passing-to-set2samplercallback4ipu: " + str(task4set2samplercallback['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['IPU'] ['CALLBACK'] = set2samplercallback4ipu()                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-sampler-set-by-set2samplercallback4ipu to: " + str(sampler4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2samplercallback4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2task:
            message2print = "{(Step J/33) passing" + "; task-passing-to-set2samplercallback4jpu: " + str(task4set2samplercallback['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['JPU'] ['CALLBACK'] = set2samplercallback4jpu()                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-sampler-set-by-set2samplercallback4jpu to: " + str(sampler4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2samplercallback4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2task:
            message2print = "{(Step K/33) passing" + "; task-passing-to-set2samplercallback4kpu: " + str(task4set2samplercallback['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['KPU'] ['CALLBACK'] = set2samplercallback4kpu()                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-sampler-set-by-set2samplercallback4kpu to: " + str(sampler4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2samplercallback4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2task:
            message2print = "{(Step L/33) passing" + "; task-passing-to-set2samplercallback4lpu: " + str(task4set2samplercallback['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['LPU'] ['CALLBACK'] = set2samplercallback4lpu()                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-sampler-set-by-set2samplercallback4lpu to: " + str(sampler4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2samplercallback4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2task:
            message2print = "{(Step M/33) passing" + "; task-passing-to-set2samplercallback4mpu: " + str(task4set2samplercallback['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['MPU'] ['CALLBACK'] = set2samplercallback4mpu()                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-sampler-set-by-set2samplercallback4mpu to: " + str(sampler4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2samplercallback4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2task:
            message2print = "{(Step N/33) passing" + "; task-passing-to-set2samplercallback4npu: " + str(task4set2samplercallback['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['NPU'] ['CALLBACK'] = set2samplercallback4npu()                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-sampler-set-by-set2samplercallback4npu to: " + str(sampler4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2samplercallback4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2task:
            message2print = "{(Step O/33) passing" + "; task-passing-to-set2samplercallback4opu: " + str(task4set2samplercallback['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['OPU'] ['CALLBACK'] = set2samplercallback4opu()                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-sampler-set-by-set2samplercallback4opu to: " + str(sampler4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2samplercallback4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2task:
            message2print = "{(Step P/33) passing" + "; task-passing-to-set2samplercallback4ppu: " + str(task4set2samplercallback['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['PPU'] ['CALLBACK'] = set2samplercallback4ppu()                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-sampler-set-by-set2samplercallback4ppu to: " + str(sampler4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2samplercallback4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2task:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-set2samplercallback4qpu: " + str(task4set2samplercallback['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['QPU'] ['CALLBACK'] = set2samplercallback4qpu()                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-sampler-set-by-set2samplercallback4qpu to: " + str(sampler4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2samplercallback4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2task:
            message2print = "{(Step R/33) passing" + "; task-passing-to-set2samplercallback4rpu: " + str(task4set2samplercallback['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['RPU'] ['CALLBACK'] = set2samplercallback4rpu()                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-sampler-set-by-set2samplercallback4rpu to: " + str(sampler4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2samplercallback4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2task:
            message2print = "{(Step S/33) passing" + "; task-passing-to-set2samplercallback4spu: " + str(task4set2samplercallback['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['SPU'] ['CALLBACK'] = set2samplercallback4spu()                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-sampler-set-by-set2samplercallback4spu to: " + str(sampler4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2samplercallback4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2task:
            message2print = "{(Step T/33) passing" + "; task-passing-to-set2samplercallback4tpu: " + str(task4set2samplercallback['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['TPU'] ['CALLBACK'] = set2samplercallback4tpu()                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-sampler-set-by-set2samplercallback4tpu to: " + str(sampler4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2samplercallback4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2task:
            message2print = "{(Step U/33) passing" + "; task-passing-to-set2samplercallback4upu: " + str(task4set2samplercallback['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['UPU'] ['CALLBACK'] = set2samplercallback4upu()                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-sampler-set-by-set2samplercallback4upu to: " + str(sampler4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2samplercallback4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2task:
            message2print = "{(Step V/33) passing" + "; task-passing-to-set2samplercallback4vpu: " + str(task4set2samplercallback['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['VPU'] ['CALLBACK'] = set2samplercallback4vpu()                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-sampler-set-by-set2samplercallback4vpu to: " + str(sampler4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2samplercallback4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2task:
            message2print = "{(Step W/33) passing" + "; task-passing-to-set2samplercallback4wpu: " + str(task4set2samplercallback['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['WPU'] ['CALLBACK'] = set2samplercallback4wpu()                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-sampler-set-by-set2samplercallback4wpu to: " + str(sampler4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2samplercallback4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2task:
            message2print = "{(Step X/33) passing" + "; task-passing-to-set2samplercallback4xpu: " + str(task4set2samplercallback['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['XPU'] ['CALLBACK'] = set2samplercallback4xpu()                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-sampler-set-by-set2samplercallback4xpu to: " + str(sampler4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of set2samplercallback4xi - set callback4xi of XPU sampler to: ", sampler4xi ['XPU'] ['CALLBACK'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2samplercallback4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2task:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-set2samplercallback4ypu: " + str(task4set2samplercallback['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['YPU'] ['CALLBACK'] = set2samplercallback4ypu()                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-sampler-set-by-set2samplercallback4ypu to: " + str(sampler4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2samplercallback4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2task:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-set2samplercallback4zpu: " + str(task4set2samplercallback['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['ZPU'] ['CALLBACK'] = set2samplercallback4zpu()                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-sampler-set-by-set2samplercallback4zpu to: " + str(sampler4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of set2samplercallback4xi - set callback4xi of ZPU sampler to: ", sampler4xi ['ZPU'] ['CALLBACK'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2samplercallback4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set2samplercallback4xi - RETURNING SAMPLER2D4XI: ", sampler4xi)
    
    message2print = "{(Step 33/33) returning" + "; sampler4xi-returning-by-set2samplercallback4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return sampler4xi
         
#</function4xi> 

 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2sampler4xi" usage = "
#1     
#   print('=' *33)          
#   print('(Step 2A/700) OF SAMPLER2D4XI5TEST - TRYING TO CREATE 2D SAMPLER4XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create2Dsampler = create2sampler4xi()                                                                 
#       print('(Step 2B/700) OF SAMPLER2D4XI5TEST - CREATED 2D SAMPLER4XI ', time4xi())
#       keys2response = response4create2Dsampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2Dsampler[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF SAMPLER2D4XI5TEST *** FAILED TO CREATE 2D SAMPLER4XI *** ', time4xi())
#2
#   print('(Step 123A/700) OF SAMPLER2D4XI5TEST - TRYING TO CREATE 2D SAMPLER for XI ', time4xi()) 
#   # 
#   try:
#       xi2xi = Sampler4Xi()                            
#       response4create2Dsampler = xi2xi.create2sampler()                                  
#       keys2response = response4create2Dsampler.keys()
#       print('(Step 122B/700) OF SAMPLER2D4XI5TEST - CREATED 2D SAMPLER ', time4xi())  
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2Dsampler[key2response])
#           # 
#   except:
#       print('(Step 123Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO CREATE 2D SAMPLER for XI ', time4xi())    
#">

# -------------------------------------------------------------------------------------------------   
def create2sampler4xi(task4samplercreate2xi=None):

    '''
    creates 2D sampler for device xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global sampler4xi
    global info2sampler4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
        
    class2print = "create2sampler4xi" 
    method2print = "create2sampler4xi"

    message2print = "{(Step 1A/70) started" + "; create2sampler4xi-started: " + str(create2sampler4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2sampler4xi at 0x00000000038D97C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4samplercreate2xi-to-create2sampler4xi: " + str(task4samplercreate2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4samplercreate2xi is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SAMPLER2D4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if sampler4xi is None:                                                                                       
                sampler4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            sampler4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4samplercreate2xi-try-by-create2sampler4xi: " + str(task4samplercreate2xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES - EACH WITH THE CONTEXT OR THEIR OWN (GIVEN BY THE CALLED ONE) 
            # ----------------------------------------------------------------------------------------- 
            sampler4xi = {} 
            sampler4xi['APU'] = create2sampler4apu()                                                                        
            sampler4xi['BPU'] = create2sampler4bpu()   
            sampler4xi['CPU'] = create2sampler4cpu()   
            sampler4xi['DPU'] = create2sampler4dpu()   
            sampler4xi['EPU'] = create2sampler4epu()   
            sampler4xi['FPU'] = create2sampler4fpu()   
            sampler4xi['GPU'] = create2sampler4gpu()   
            sampler4xi['HPU'] = create2sampler4hpu()   
            sampler4xi['IPU'] = create2sampler4ipu()   
            sampler4xi['JPU'] = create2sampler4jpu()   
            sampler4xi['KPU'] = create2sampler4kpu()   
            sampler4xi['LPU'] = create2sampler4lpu()   
            sampler4xi['MPU'] = create2sampler4mpu()   
            sampler4xi['NPU'] = create2sampler4npu()   
            sampler4xi['OPU'] = create2sampler4opu()   
            sampler4xi['PPU'] = create2sampler4ppu()   
            sampler4xi['QPU'] = create2sampler4qpu()   
            sampler4xi['RPU'] = create2sampler4rpu()   
            sampler4xi['SPU'] = create2sampler4spu()   
            sampler4xi['TPU'] = create2sampler4tpu()   
            sampler4xi['UPU'] = create2sampler4upu()   
            sampler4xi['VPU'] = create2sampler4vpu()   
            sampler4xi['XPU'] = create2sampler4xpu()   
            sampler4xi['WPU'] = create2sampler4wpu()   
            sampler4xi['YPU'] = create2sampler4ypu()   
            sampler4xi['ZPU'] = create2sampler4zpu()   
            
            message2print = "{(Step 3A/33) initialized" + "; sampler4xi-initialized-by-create2sampler4xi to: " + str(sampler4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; sampler4xi-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['APU'] = create2sampler4apu(task4samplercreate2xi['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2sampler4xi to: " + str(sampler4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['BPU'] = create2sampler4bpu(task4samplercreate2xi['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['CPU'] = create2sampler4cpu(task4samplercreate2xi['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['DPU'] = create2sampler4dpu(task4samplercreate2xi['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['EPU'] = create2sampler4epu(task4samplercreate2xi['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2sampler4xi to: " + str(sampler4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['FPU'] = create2sampler4fpu(task4samplercreate2xi['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['GPU'] = create2sampler4gpu(task4samplercreate2xi['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['HPU'] = create2sampler4hpu(task4samplercreate2xi['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['IPU'] = create2sampler4ipu(task4samplercreate2xi['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2sampler4xi to: " + str(sampler4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['JPU'] = create2sampler4jpu(task4samplercreate2xi['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['KPU'] = create2sampler4kpu(task4samplercreate2xi['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['LPU'] = create2sampler4lpu(task4samplercreate2xi['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['MPU'] = create2sampler4mpu(task4samplercreate2xi['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['NPU'] = create2sampler4npu(task4samplercreate2xi['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2sampler4xi to: " + str(sampler4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['OPU'] = create2sampler4opu(task4samplercreate2xi['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2sampler4xi to: " + str(sampler4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['PPU'] = create2sampler4ppu(task4samplercreate2xi['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2sampler4xi to: " + str(sampler4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['QPU'] = create2sampler4qpu(task4samplercreate2xi['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['RPU'] = create2sampler4rpu(task4samplercreate2xi['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['SPU'] = create2sampler4spu(task4samplercreate2xi['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2sampler4xi to: " + str(sampler4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['TPU'] = create2sampler4tpu(task4samplercreate2xi['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['UPU'] = create2sampler4upu(task4samplercreate2xi['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2sampler4xi to: " + str(sampler4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['VPU'] = create2sampler4vpu(task4samplercreate2xi['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['WPU'] = create2sampler4wpu(task4samplercreate2xi['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['XPU'] = create2sampler4xpu(task4samplercreate2xi['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['YPU'] = create2sampler4ypu(task4samplercreate2xi['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2sampler4xi to: " + str(sampler4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            sampler4xi['ZPU'] = create2sampler4zpu(task4samplercreate2xi['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2sampler4xi to: " + str(sampler4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create2sampler4xi - RETURNING SAMPLER2D4XI: ", sampler4xi)
            
    message2print = "{(Step 33/33) returning" + "; sampler4xi-returning-by-create2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return sampler4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2sampler4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------
#   # (10) FINALLY SET 2D SAMPLER AFTER HAVING PROVIDED VALUES FOR REQUIRED PROCESSING UNITS                            
#   # ---------------------------------------------------------------------------------------------          
#   response4set2Dsampler = {} 
#   print('(Step 10A/700) OF SAMPLER2D4XI5TEST - TRYING TO SET 2D SAMPLER4XI ', time4xi())   
#   try:                               
#       response4set2Dsampler = set2sampler4xi(task4set2sampler)                                                                                                         
#                                                                                     
#       print('(Step 10B/700) OF SAMPLER2D4XI5TEST - SET 2D SAMPLER4XI ', time4xi())
#       keys2response = response4set2Dsampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4set2Dsampler[key2response])
#           # APU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
#           # ....
#           # ZPU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
#   except:
#       print('(Step 10Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO SET 2D SAMPLER4XI *** ', time4xi())  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2sampler4xi(task4samplerset2xi=None):

    '''
    sets 2D samplers for xi device
    '''
    global platform2xi
    global device2xi
    global context2xi    
    global sampler4xi
    global info2sampler4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class2print = "set2sampler4xi"
    method2print = "set2sampler4xi"

    message2print = "{(Step 1A/33) started" + "; set2sampler4xi-started: " + str(set2sampler4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2sampler4xi at 0x0000000003A62848> 
    
    message2print = "{(Step 1B/33) passed" + "; task4samplerset2xi-to-set2sampler4xi: " + str(task4samplerset2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
            
    code2ack  = ' '
    code2nack = ' '
    if sampler4xi is None:
        sampler4xi = create2sampler4xi()                                                                            
                                
        message2print = "{(Step 1C/33) set" + "; sampler4xi-set-by-set2sampler4xi to: " + str(sampler4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A/33) passing" + "; task-passing-to-set2sampler4apu: " + str(task4set2sampler['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['APU'] = set2sampler4apu(task4set2sampler['APU'])                                                      # 
         
        message2print = "{(Step A1/33) set" + "; apu-sampler-set-by-set2sampler4apu to: " + str(sampler4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'A1-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2sampler4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B/33) passing" + "; task-passing-to-set2sampler4bpu: " + str(task4set2sampler['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['BPU'] = set2sampler4bpu(task4set2sampler['BPU'])                                                      # 
         
        message2print = "{(Step B1/33) set" + "; bpu-sampler-set-by-set2sampler4bpu to: " + str(sampler4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'B1-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2sampler4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C/33) passing" + "; task-passing-to-set2sampler4cpu: " + str(task4set2sampler['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['CPU'] = set2sampler4cpu(task4set2sampler['CPU'])                                                      # 
         
        message2print = "{(Step C1/33) set" + "; cpu-sampler-set-by-set2sampler4cpu to: " + str(sampler4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'C1-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2sampler4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D/33) passing" + "; task-passing-to-set2sampler4dpu: " + str(task4set2sampler['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['DPU'] = set2sampler4dpu(task4set2sampler['DPU'])                                                      # 
         
        message2print = "{(Step D1/33) set" + "; dpu-sampler-set-by-set2sampler4dpu to: " + str(sampler4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'D1-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2sampler4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E/33) passing" + "; task-passing-to-set2sampler4epu: " + str(task4set2sampler['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['EPU'] = set2sampler4epu(task4set2sampler['EPU'])                                                      # 
         
        message2print = "{(Step E1/33) set" + "; epu-sampler-set-by-set2sampler4epu to: " + str(sampler4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'E1-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2sampler4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F/33) passing" + "; task-passing-to-set2sampler4fpu: " + str(task4set2sampler['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['FPU'] = set2sampler4fpu(task4set2sampler['FPU'])                                                      # 
         
        message2print = "{(Step F1/33) set" + "; fpu-sampler-set-by-set2sampler4fpu to: " + str(sampler4xi ['PU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'F1-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2sampler4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G/33) passing" + "; task-passing-to-set2sampler4gpu: " + str(task4set2sampler['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['GPU'] = set2sampler4gpu(task4set2sampler['GPU'])                                                      # 
         
        message2print = "{(Step G1/33) set" + "; gpu-sampler-set-by-set2sampler4gpu to: " + str(sampler4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'G1-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2sampler4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H/33) passing" + "; task-passing-to-set2sampler4hpu: " + str(task4set2sampler['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['HPU'] = set2sampler4hpu(task4set2sampler['HPU'])                                                      # 
         
        message2print = "{(Step H1/33) set" + "; hpu-sampler-set-by-set2sampler4hpu to: " + str(sampler4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'H1-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2sampler4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I/33) passing" + "; task-passing-to-set2sampler4ipu: " + str(task4set2sampler['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['IPU'] = set2sampler4ipu(task4set2sampler['IPU'])                                                      # 
         
        message2print = "{(Step I1/33) set" + "; ipu-sampler-set-by-set2sampler4ipu to: " + str(sampler4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'I1-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2sampler4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J/33) passing" + "; task-passing-to-set2sampler4jpu: " + str(task4set2sampler['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['JPU'] = set2sampler4jpu(task4set2sampler['JPU'])                                                      # 
         
        message2print = "{(Step J1/33) set" + "; jpu-sampler-set-by-set2sampler4jpu to: " + str(sampler4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'J1-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2sampler4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K/33) passing" + "; task-passing-to-set2sampler4kpu: " + str(task4set2sampler['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['KPU'] = set2sampler4kpu(task4set2sampler['KPU'])                                                      # 
         
        message2print = "{(Step K1/33) set" + "; kpu-sampler-set-by-set2sampler4kpu to: " + str(sampler4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'K1-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2sampler4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L/33) passing" + "; task-passing-to-set2sampler4lpu: " + str(task4set2sampler['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['LPU'] = set2sampler4lpu(task4set2sampler['LPU'])                                                      # 
         
        message2print = "{(Step L1/33) set" + "; lpu-sampler-set-by-set2sampler4lpu to: " + str(sampler4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + '1-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2sampler4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M/33) passing" + "; task-passing-to-set2sampler4mpu: " + str(task4set2sampler['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['MPU'] = set2sampler4mpu(task4set2sampler['MPU'])                                                      # 
         
        message2print = "{(Step M1/33) set" + "; mpu-sampler-set-by-set2sampler4mpu to: " + str(sampler4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'M1-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2sampler4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N/33) passing" + "; task-passing-to-set2sampler4npu: " + str(task4set2sampler['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['NPU'] = set2sampler4npu(task4set2sampler['NPU'])                                                      # 
         
        message2print = "{(Step N1/33) set" + "; npu-sampler-set-by-set2sampler4npu to: " + str(sampler4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'N1-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2sampler4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O/33) passing" + "; task-passing-to-set2sampler4opu: " + str(task4set2sampler['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['OPU'] = set2sampler4opu(task4set2sampler['OPU'])                                                      # 
         
        message2print = "{(Step O1/33) set" + "; opu-sampler-set-by-set2sampler4opu to: " + str(sampler4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'O1-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2sampler4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P/33) passing" + "; task-passing-to-set2sampler4ppu: " + str(task4set2sampler['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['PPU'] = set2sampler4ppu(task4set2sampler['PPU'])                                                      # 
         
        message2print = "{(Step P1/33) set" + "; ppu-sampler-set-by-set2sampler4ppu to: " + str(sampler4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'P1-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2sampler4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q/33) passing" + "; task-passing-to-set2sampler4qpu: " + str(task4set2sampler['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['QPU'] = set2sampler4qpu(task4set2sampler['QPU'])                                                      # 
         
        message2print = "{(Step Q1/33) set" + "; qpu-sampler-set-by-set2sampler4qpu to: " + str(sampler4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Q1-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2sampler4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R/33) passing" + "; task-passing-to-set2sampler4rpu: " + str(task4set2sampler['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['RPU'] = set2sampler4rpu(task4set2sampler['RPU'])                                                      # 
         
        message2print = "{(Step R1/33) set" + "; rpu-sampler-set-by-set2sampler4rpu to: " + str(sampler4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'R1-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2sampler4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S/33) passing" + "; task-passing-to-set2sampler4spu: " + str(task4set2sampler['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['SPU'] = set2sampler4spu(task4set2sampler['SPU'])                                                      # 
         
        message2print = "{(Step S1/33) set" + "; spu-sampler-set-by-set2sampler4spu to: " + str(sampler4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'S1-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2sampler4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T/33) passing" + "; task-passing-to-set2sampler4tpu: " + str(task4set2sampler['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['TPU'] = set2sampler4tpu(task4set2sampler['TPU'])                                                      # 
         
        message2print = "{(Step T1/33) set" + "; tpu-sampler-set-by-set2sampler4tpu to: " + str(sampler4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'T1-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2sampler4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U/33) passing" + "; task-passing-to-set2sampler4upu: " + str(task4set2sampler['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['UPU'] = set2sampler4upu(task4set2sampler['UPU'])                                                      # 
         
        message2print = "{(Step U1/33) set" + "; upu-sampler-set-by-set2sampler4upu to: " + str(sampler4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'U1-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2sampler4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V/33) passing" + "; task-passing-to-set2sampler4vpu: " + str(task4set2sampler['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['VPU'] = set2sampler4vpu(task4set2sampler['VPU'])                                                      # 
         
        message2print = "{(Step V1/33) set" + "; vpu-sampler-set-by-set2sampler4vpu to: " + str(sampler4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'V1-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2sampler4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W/33) passing" + "; task-passing-to-set2sampler4wpu: " + str(task4set2sampler['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['WPU'] = set2sampler4wpu(task4set2sampler['WPU'])                                                      # 
         
        message2print = "{(Step W1/33) set" + "; wpu-sampler-set-by-set2sampler4wpu to: " + str(sampler4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'W1-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2sampler4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X/33) passing" + "; task-passing-to-set2sampler4xpu: " + str(task4set2sampler['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['XPU'] = set2sampler4xpu(task4set2sampler['XPU'])                                                      # 
         
        message2print = "{(Step X1/33) set" + "; xpu-sampler-set-by-set2sampler4xpu to: " + str(sampler4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'X1-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2sampler4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y/33) passing" + "; task-passing-to-set2sampler4ypu: " + str(task4set2sampler['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['YPU'] = set2sampler4ypu(task4set2sampler['YPU'])                                                      # 
         
        message2print = "{(Step Y1/33) set" + "; ypu-sampler-set-by-set2sampler4ypu to: " + str(sampler4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Y1-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2sampler4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z/33) passing" + "; task-passing-to-set2sampler4zpu: " + str(task4set2sampler['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        sampler4xi ['ZPU'] = set2sampler4zpu(task4set2sampler['ZPU'])                                                      # 
         
        message2print = "{(Step Z1/33) set" + "; zpu-sampler-set-by-set2sampler4zpu to: " + str(sampler4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Z1-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2sampler4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print('(Step 33/33) of set2sampler4xi - RETURNING SAMPLER2D4XI:  ', sampler4xi) 
    
    message2print = "{(Step 33/33) returning" + "; sampler4xi-returning-by-set2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    
    return sampler4xi
           
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2sampler4xi" usage = "
#
#   task4release2sampler  = {}
#   task4release2sampler ['APU']  = {}
#   task4release2sampler ['APU'] ['COUNT2REFERENCE'] = 1
#   task4release2sampler ['ZPU']  = {}
#   task4release2sampler ['ZPU'] ['COUNT2REFERENCE'] = 1     
#   response4release2sampler = {}    
#      
#   print('(Step 11A/700) OF SAMPLER2D4XI5TEST - TRYING TO RELEASE 2D SAMPLER OF XI DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4release2Dsampler = release2sampler4xi(task4release2sampler)                                                                                             
#       print('(Step 11B/700) OF SAMPLER2D4XI5TEST - RELEASED 2D SAMPLER OF XI DEVICE ', time4xi())                           
#       keys2response = response4release2Dsampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4release2Dsampler[key2response])
#           # APU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
#           # BPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE':
#           # ...
#           # ZPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...            
#   except:
#       print('(Step 11Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO RELEASE SAMPLER OF XI DEVICE ', time4xi())
#                 
#">
# -------------------------------------------------------------------------------------------------   
def release2sampler4xi(task4release2sampler=None):

    '''
    releases sampler4xi
    '''
    global sampler4xi 
    global info2sampler4xi 

    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "release2sampler4xi"
    method2print = "release2sampler4xi" 

    message2print = "{(Step 1A/33) started" + "; release2sampler4xi-started: " + str(release2sampler4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function release2sampler4xi at 0x0000000004D5DA48>
    
    message2print = "{(Step 1B/33) passed" + "; task4release2sampler-to-release2sampler4xi: " + str(task4release2sampler) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'ZPU': {'COUNT2REFERENCE': 1}, 'APU': {'COUNT2REFERENCE': 1}
    
    if task4release2sampler is None:
        task4release2sampler = {}
             
    code2ack  = ' '
    code2nack = ' '

    if sampler4xi is None:
        sampler4xi = create2sampler4xi()                                                                            
                                
        message2print = "{(Step 1C/33) release" + "; sampler4xi-release-by-release2sampler4xi to: " + str(sampler4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        
    keys2release = task4release2sampler.keys()

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'APU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step A/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step A1/33) passing" + "; task-passing-to-release2sampler4apu: " + str(task4release2sampler['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            sampler4xi ['APU'] = release2sampler4apu()                                                              # 
             
            message2print = "{(Step A2/33) release" + "; apu-sampler-release-by-release2sampler4apu to: " + str(sampler4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ... 
            
         
            code2ack  = code2ack + 'A2-'
        else:
            pass    
    except:
        message2print = "{(Step AZ/33) yielded" + "; apu-yielded-by-release2sampler4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'BPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step B/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step B1/33) passing" + "; task-passing-to-release2sampler4bpu: " + str(task4release2sampler['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['BPU'] = release2sampler4bpu()                                                              # 
         
            message2print = "{(Step B2/33) release" + "; bpu-sampler-release-by-release2sampler4bpu to: " + str(sampler4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'B2-'
        else:
            pass    
    except:
        message2print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-release2sampler4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'CPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step C/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step C1/33) passing" + "; task-passing-to-release2sampler4cpu: " + str(task4release2sampler['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['CPU'] = release2sampler4cpu()                                                              # 
         
            message2print = "{(Step C2/33) release" + "; cpu-sampler-release-by-release2sampler4cpu to: " + str(sampler4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'C2-'
        else:
            pass    
    except:
        message2print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-release2sampler4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'DPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step D/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step D1/33) passing" + "; task-passing-to-release2sampler4dpu: " + str(task4release2sampler['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['DPU'] = release2sampler4dpu()                                                              # 
         
            message2print = "{(Step D2/33) release" + "; dpu-sampler-release-by-release2sampler4dpu to: " + str(sampler4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'D2-'
        else:
            pass    
    except:
        message2print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-release2sampler4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'EPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step E/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step E1/33) passing" + "; task-passing-to-release2sampler4epu: " + str(task4release2sampler['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['EPU'] = release2sampler4epu()                                                              # 
         
            message2print = "{(Step E2/33) release" + "; epu-sampler-release-by-release2sampler4epu to: " + str(sampler4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'E2-'
        else:
            pass    
    except:
        message2print = "{(Step EZ/33) yielded" + "; epu-yielded-by-release2sampler4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'FPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step F/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step F1/33) passing" + "; task-passing-to-release2sampler4fpu: " + str(task4release2sampler['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['FPU'] = release2sampler4fpu()                                                              # 
         
            message2print = "{(Step F2/33) release" + "; fpu-sampler-release-by-release2sampler4fpu to: " + str(sampler4xi ['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'F2-'
        else:
            pass    
    except:
        message2print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-release2sampler4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'GPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step G/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step G1/33) passing" + "; task-passing-to-release2sampler4gpu: " + str(task4release2sampler['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['GPU'] = release2sampler4gpu()                                                              # 
         
            message2print = "{(Step G2/33) release" + "; gpu-sampler-release-by-release2sampler4gpu to: " + str(sampler4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'G2-'
        else:
            pass    
    except:
        message2print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-release2sampler4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'HPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step H/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step H1/33) passing" + "; task-passing-to-release2sampler4hpu: " + str(task4release2sampler['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['HPU'] = release2sampler4hpu()                                                              # 
         
            message2print = "{(Step H2/33) release" + "; hpu-sampler-release-by-release2sampler4hpu to: " + str(sampler4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'H2-'
        else:
            pass    
    except:
        message2print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-release2sampler4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'IPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step I/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step I1/33) passing" + "; task-passing-to-release2sampler4ipu: " + str(task4release2sampler['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['IPU'] = release2sampler4ipu()                                                              # 
         
            message2print = "{(Step I2/33) release" + "; ipu-sampler-release-by-release2sampler4ipu to: " + str(sampler4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'I2-'
        else:
            pass    
    except:
        message2print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-release2sampler4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'JPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step J/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step J1/33) passing" + "; task-passing-to-release2sampler4jpu: " + str(task4release2sampler['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['JPU'] = release2sampler4jpu()                                                              # 
         
            message2print = "{(Step J2/33) release" + "; jpu-sampler-release-by-release2sampler4jpu to: " + str(sampler4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'J2-'
        else:
            pass    
    except:
        message2print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-release2sampler4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'KPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step K/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step K1/33) passing" + "; task-passing-to-release2sampler4kpu: " + str(task4release2sampler['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['KPU'] = release2sampler4kpu()                                                              # 
         
            message2print = "{(Step K2/33) release" + "; kpu-sampler-release-by-release2sampler4kpu to: " + str(sampler4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'K2-'
        else:
            pass    
    except:
        message2print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-release2sampler4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'LPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step L/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step L1/33) passing" + "; task-passing-to-release2sampler4lpu: " + str(task4release2sampler['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['LPU'] = release2sampler4lpu()                                                              # 
         
            message2print = "{(Step L2/33) release" + "; lpu-sampler-release-by-release2sampler4lpu to: " + str(sampler4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'L2-'
        else:
            pass    
    except:
        message2print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-release2sampler4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'MPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step M/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step M1/33) passing" + "; task-passing-to-release2sampler4mpu: " + str(task4release2sampler['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['MPU'] = release2sampler4mpu()                                                              # 
         
            message2print = "{(Step M2/33) release" + "; mpu-sampler-release-by-release2sampler4mpu to: " + str(sampler4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'M2-'
        else:
            pass    
    except:
        message2print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-release2sampler4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'NPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step N/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step N1/33) passing" + "; task-passing-to-release2sampler4npu: " + str(task4release2sampler['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['NPU'] = release2sampler4npu()                                                              # 
         
            message2print = "{(Step N2/33) release" + "; npu-sampler-release-by-release2sampler4npu to: " + str(sampler4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'N2-'
        else:
            pass    
    except:
        message2print = "{(Step NZ/33) yielded" + "; npu-yielded-by-release2sampler4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'OPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step O/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step O1/33) passing" + "; task-passing-to-release2sampler4opu: " + str(task4release2sampler['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['OPU'] = release2sampler4opu()                                                              # 
         
            message2print = "{(Step O2/33) release" + "; opu-sampler-release-by-release2sampler4opu to: " + str(sampler4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'O2-'
        else:
            pass    
    except:
        message2print = "{(Step OZ/33) yielded" + "; opu-yielded-by-release2sampler4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'PPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step P/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step P1/33) passing" + "; task-passing-to-release2sampler4ppu: " + str(task4release2sampler['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['PPU'] = release2sampler4ppu()                                                              # 
         
            message2print = "{(Step P2/33) release" + "; ppu-sampler-release-by-release2sampler4ppu to: " + str(sampler4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'P2-'
        else:
            pass    
    except:
        message2print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-release2sampler4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'QPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step Q/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Q1/33) passing" + "; task-passing-to-release2sampler4qpu: " + str(task4release2sampler['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['QPU'] = release2sampler4qpu()                                                              # 
         
            message2print = "{(Step Q2/33) release" + "; qpu-sampler-release-by-release2sampler4qpu to: " + str(sampler4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'Q2-'
        else:
            pass    
    except:
        message2print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-release2sampler4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'RPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step R/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step R1/33) passing" + "; task-passing-to-release2sampler4rpu: " + str(task4release2sampler['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['RPU'] = release2sampler4rpu()                                                              # 
         
            message2print = "{(Step R2/33) release" + "; rpu-sampler-release-by-release2sampler4rpu to: " + str(sampler4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'R2-'
        else:
            pass    
    except:
        message2print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-release2sampler4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'SPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step S/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step S1/33) passing" + "; task-passing-to-release2sampler4spu: " + str(task4release2sampler['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['SPU'] = release2sampler4spu()                                                              # 
         
            message2print = "{(Step S2/33) release" + "; spu-sampler-release-by-release2sampler4spu to: " + str(sampler4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'S2-'
        else:
            pass    
    except:
        message2print = "{(Step SZ/33) yielded" + "; spu-yielded-by-release2sampler4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'TPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step T/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step T1/33) passing" + "; task-passing-to-release2sampler4tpu: " + str(task4release2sampler['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['TPU'] = release2sampler4tpu()                                                              # 
         
            message2print = "{(Step T2/33) release" + "; tpu-sampler-release-by-release2sampler4tpu to: " + str(sampler4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'T2-'
        else:
            pass    
    except:
        message2print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-release2sampler4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'UPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step U/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step U1/33) passing" + "; task-passing-to-release2sampler4upu: " + str(task4release2sampler['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['UPU'] = release2sampler4upu()                                                              # 
         
            message2print = "{(Step U2/33) release" + "; upu-sampler-release-by-release2sampler4upu to: " + str(sampler4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'U2-'
        else:
            pass    
    except:
        message2print = "{(Step UZ/33) yielded" + "; upu-yielded-by-release2sampler4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'VPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step V/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step V1/33) passing" + "; task-passing-to-release2sampler4vpu: " + str(task4release2sampler['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['VPU'] = release2sampler4vpu()                                                              # 
         
            message2print = "{(Step V2/33) release" + "; vpu-sampler-release-by-release2sampler4vpu to: " + str(sampler4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'V2-'
        else:
            pass    
    except:
        message2print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-release2sampler4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'WPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step W/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step W1/33) passing" + "; task-passing-to-release2sampler4wpu: " + str(task4release2sampler['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['WPU'] = release2sampler4wpu()                                                              # 
         
            message2print = "{(Step W2/33) release" + "; wpu-sampler-release-by-release2sampler4wpu to: " + str(sampler4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'W2-'
        else:
            pass    
    except:
        message2print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-release2sampler4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'XPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step X/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step X1/33) passing" + "; task-passing-to-release2sampler4xpu: " + str(task4release2sampler['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['XPU'] = release2sampler4xpu()                                                              # 
         
            message2print = "{(Step X2/33) release" + "; xpu-sampler-release-by-release2sampler4xpu to: " + str(sampler4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'X2-'
        else:
            pass    
    except:
        message2print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-release2sampler4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'YPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step Y/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Y1/33) passing" + "; task-passing-to-release2sampler4ypu: " + str(task4release2sampler['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['YPU'] = release2sampler4ypu()                                                              # 
         
            message2print = "{(Step Y2/33) release" + "; ypu-sampler-release-by-release2sampler4ypu to: " + str(sampler4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'Y2-'
        else:
            pass    
    except:
        message2print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-release2sampler4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'ZPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step Z/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Z1/33) passing" + "; task-passing-to-release2sampler4zpu: " + str(task4release2sampler['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['ZPU'] = release2sampler4zpu()                                                              # 
         
            message2print = "{(Step Z2/33) release" + "; zpu-sampler-release-by-release2sampler4zpu to: " + str(sampler4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
     
            code2ack  = code2ack + 'Z2-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-release2sampler4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; sampler4xi-returning-by-release2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    if debug is True:
        print('(Step 33/33) of release2sampler4xi - RETURNING SAMPLER2D4XI:  ', sampler4xi) 
        #  
         
    return sampler4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2sampler4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------
#   # (13) REFERENCE COUNT FOR TWO PROCESSING UNITS RETAINED BY INCREMENTING COUNT WITH 1             
#   # ---------------------------------------------------------------------------------------------    
#   task4retain2sampler  = {}
#   task4retain2sampler ['APU']  = {}
#   task4retain2sampler ['APU'] ['DIMENSION'] = 2 
#   task4retain2sampler ['APU'] ['COUNT2REFERENCE'] = 1
#   task4retain2sampler ['ZPU']  = {}
#   task4retain2sampler ['ZPU'] ['DIMENSION'] = 2 
#   task4retain2sampler ['ZPU'] ['COUNT2REFERENCE'] = 1    
#    
#   response4retain2Dsampler = {}
#   print('(Step 13A/700) OF SAMPLER2D4XI5TEST - TRYING TO RETAIN 2D SAMPLER OF XI DEVICE ', time4xi())   
#   try:                               
#       response4retain2Dsampler = retain2sampler4xi(task4retain2sampler)                                                                                                 
#       print('(Step 13B/700) OF SAMPLER2D4XI5TEST - RESPONSE4RETAIN2DSAMPLER : ', time4xi())                         
#       keys2response = response4retain2Dsampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', len(response4retain2Dsampler[key2response]))
#           # APU  :  20
#           # ...
#           # XPU  :  20 <-- length is the same in all processing units
#           # YPU  :  20
#           # ZPU  :  20
#                  
#   except:
#       print('(Step 13Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO RETAIN 2D SAMPLER OF XI DEVICE ', time4xi())   
#
#">
# -------------------------------------------------------------------------------------------------   
def retain2sampler4xi(task4retain2sampler=None):

    '''
    retains either sampler4xi
    '''
    global sampler4xi 
    global info2sampler4xi

    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "retain2sampler4xi"
    method2print = "retain2sampler4xi"

    message2print = "{(Step 1A/33) started" + "; retain2sampler4xi-started: " + str(retain2sampler4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function retain2sampler4xi at 0x0000000003A9E948>   
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2sampler-to-retain2sampler4xi: " + str(task4retain2sampler) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #
    if task4retain2sampler is None:
        task4retain2sampler = {}
        
    keys2retain = task4retain2sampler    
    
    code2ack  = ' '
    code2nack = ' '
    
    if sampler4xi is None:
        sampler4xi = create2sampler4xi()                                                                            
                                
        message2print = "{(Step 1C/33) retain" + "; sampler4xi-retain-by-retain2sampler4xi to: " + str(sampler4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'APU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step A/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step A1/33) passing" + "; task-passing-to-retain2sampler4apu: " + str(task4retain2sampler['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['APU'] = retain2sampler4apu()                                                              # 
         
            message2print = "{(Step A2/33) retain" + "; apu-sampler-retain-by-retain2sampler4apu to: " + str(sampler4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'AZ-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-retain2sampler4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'BPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step B/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step B1/33) passing" + "; task-passing-to-retain2sampler4bpu: " + str(task4retain2sampler['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['BPU'] = retain2sampler4bpu()                                                              # 
         
            message2print = "{(Step B2/33) retain" + "; bpu-sampler-retain-by-retain2sampler4bpu to: " + str(sampler4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'BZ-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-retain2sampler4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'CPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step C/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step C1/33) passing" + "; task-passing-to-retain2sampler4cpu: " + str(task4retain2sampler['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['CPU'] = retain2sampler4cpu()                                                              # 
         
            message2print = "{(Step C2/33) retain" + "; cpu-sampler-retain-by-retain2sampler4cpu to: " + str(sampler4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'CZ-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-retain2sampler4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'DPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step D/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step D1/33) passing" + "; task-passing-to-retain2sampler4dpu: " + str(task4retain2sampler['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['DPU'] = retain2sampler4dpu()                                                              # 
         
            message2print = "{(Step D2/33) retain" + "; dpu-sampler-retain-by-retain2sampler4dpu to: " + str(sampler4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'DZ-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-retain2sampler4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'EPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step E/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step E1/33) passing" + "; task-passing-to-retain2sampler4epu: " + str(task4retain2sampler['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['EPU'] = retain2sampler4epu()                                                               # 
         
            message2print = "{(Step E2/33) retain" + "; epu-sampler-retain-by-retain2sampler4epu to: " + str(sampler4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'EZ-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-retain2sampler4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'FPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step F/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step F1/33) passing" + "; task-passing-to-retain2sampler4fpu: " + str(task4retain2sampler['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['FPU'] = retain2sampler4fpu()                                                               # 
         
            message2print = "{(Step F2/33) retain" + "; fpu-sampler-retain-by-retain2sampler4fpu to: " + str(sampler4xi ['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'FZ-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-retain2sampler4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'GPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step G/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step G1/33) passing" + "; task-passing-to-retain2sampler4gpu: " + str(task4retain2sampler['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['GPU'] = retain2sampler4gpu()                                                               # 
         
            message2print = "{(Step G2/33) retain" + "; gpu-sampler-retain-by-retain2sampler4gpu to: " + str(sampler4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'GZ-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-retain2sampler4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'HPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step H/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step H1/33) passing" + "; task-passing-to-retain2sampler4hpu: " + str(task4retain2sampler['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['HPU'] = retain2sampler4hpu()                                                               # 
         
            message2print = "{(Step H2/33) retain" + "; hpu-sampler-retain-by-retain2sampler4hpu to: " + str(sampler4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'HZ-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-retain2sampler4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'IPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step I/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step I1/33) passing" + "; task-passing-to-retain2sampler4ipu: " + str(task4retain2sampler['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['IPU'] = retain2sampler4ipu()                                                               # 
         
            message2print = "{(Step I2/33) retain" + "; ipu-sampler-retain-by-retain2sampler4ipu to: " + str(sampler4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'IZ-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-retain2sampler4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'JPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step J/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step J1/33) passing" + "; task-passing-to-retain2sampler4jpu: " + str(task4retain2sampler['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['JPU'] = retain2sampler4jpu()                                                               # 
         
            message2print = "{(Step J2/33) retain" + "; jpu-sampler-retain-by-retain2sampler4jpu to: " + str(sampler4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'JZ-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-retain2sampler4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'KPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step K/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step K1/33) passing" + "; task-passing-to-retain2sampler4kpu: " + str(task4retain2sampler['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['KPU'] = retain2sampler4kpu()                                                               # 
         
            message2print = "{(Step K2/33) retain" + "; kpu-sampler-retain-by-retain2sampler4kpu to: " + str(sampler4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'KZ-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-retain2sampler4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'LPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step L/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step L1/33) passing" + "; task-passing-to-retain2sampler4lpu: " + str(task4retain2sampler['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['LPU'] = retain2sampler4lpu()                                                               # 
         
            message2print = "{(Step L2/33) retain" + "; lpu-sampler-retain-by-retain2sampler4lpu to: " + str(sampler4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'LZ-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-retain2sampler4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'MPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step M/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step M1/33) passing" + "; task-passing-to-retain2sampler4mpu: " + str(task4retain2sampler['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['MPU'] = retain2sampler4mpu()                                                               # 
         
            message2print = "{(Step M2/33) retain" + "; mpu-sampler-retain-by-retain2sampler4mpu to: " + str(sampler4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'MZ-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-retain2sampler4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'NPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step N/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step N1/33) passing" + "; task-passing-to-retain2sampler4npu: " + str(task4retain2sampler['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['NPU'] = retain2sampler4npu()                                                               # 
         
            message2print = "{(Step N2/33) retain" + "; npu-sampler-retain-by-retain2sampler4npu to: " + str(sampler4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'NZ-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-retain2sampler4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'OPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step O/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step O1/33) passing" + "; task-passing-to-retain2sampler4opu: " + str(task4retain2sampler['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['OPU'] = retain2sampler4opu()                                                               # 
         
            message2print = "{(Step O2/33) retain" + "; opu-sampler-retain-by-retain2sampler4opu to: " + str(sampler4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'OZ-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-retain2sampler4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'PPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step P/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step P1/33) passing" + "; task-passing-to-retain2sampler4ppu: " + str(task4retain2sampler['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['PPU'] = retain2sampler4ppu()                                                               # 
         
            message2print = "{(Step P2/33) retain" + "; ppu-sampler-retain-by-retain2sampler4ppu to: " + str(sampler4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'PZ-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; pu-yielded-by-retain2sampler4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'QPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step Q/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Q1/33) passing" + "; task-passing-to-retain2sampler4qpu: " + str(task4retain2sampler['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['QPU'] = retain2sampler4qpu()                                                               # 
         
            message2print = "{(Step Q2/33) retain" + "; qpu-sampler-retain-by-retain2sampler4qpu to: " + str(sampler4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'QZ-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-retain2sampler4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'RPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step R/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step R1/33) passing" + "; task-passing-to-retain2sampler4rpu: " + str(task4retain2sampler['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['RPU'] = retain2sampler4rpu()                                                               # 
         
            message2print = "{(Step R2/33) retain" + "; rpu-sampler-retain-by-retain2sampler4rpu to: " + str(sampler4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'RZ-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-retain2sampler4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'SPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step S/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step S1/33) passing" + "; task-passing-to-retain2sampler4spu: " + str(task4retain2sampler['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['SPU'] = retain2sampler4spu()                                                               # 
         
            message2print = "{(Step S2/33) retain" + "; spu-sampler-retain-by-retain2sampler4spu to: " + str(sampler4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'SZ-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-retain2sampler4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'TPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step T/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step T1/33) passing" + "; task-passing-to-retain2sampler4tpu: " + str(task4retain2sampler['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['TPU'] = retain2sampler4tpu()                                                               # 
         
            message2print = "{(Step T2/33) retain" + "; tpu-sampler-retain-by-retain2sampler4tpu to: " + str(sampler4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'TZ-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-retain2sampler4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'UPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step U/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step U1/33) passing" + "; task-passing-to-retain2sampler4upu: " + str(task4retain2sampler['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['UPU'] = retain2sampler4upu()                                                               # 
         
            message2print = "{(Step U2/33) retain" + "; upu-sampler-retain-by-retain2sampler4upu to: " + str(sampler4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'UZ-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-retain2sampler4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'VPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step V/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step V1/33) passing" + "; task-passing-to-retain2sampler4vpu: " + str(task4retain2sampler['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['VPU'] = retain2sampler4vpu()                                                               # 
         
            message2print = "{(Step V2/33) retain" + "; vpu-sampler-retain-by-retain2sampler4vpu to: " + str(sampler4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'VZ-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-retain2sampler4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'WPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step W/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step W1/33) passing" + "; task-passing-to-retain2sampler4wpu: " + str(task4retain2sampler['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['WPU'] = retain2sampler4wpu()                                                               # 
         
            message2print = "{(Step W2/33) retain" + "; wpu-sampler-retain-by-retain2sampler4wpu to: " + str(sampler4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'WZ-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-retain2sampler4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'XPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step X/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step X1/33) passing" + "; task-passing-to-retain2sampler4xpu: " + str(task4retain2sampler['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['XPU'] = retain2sampler4xpu()                                                               # 
         
            message2print = "{(Step X2/33) retain" + "; xpu-sampler-retain-by-retain2sampler4xpu to: " + str(sampler4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'XZ-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-retain2sampler4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'YPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step Y/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Y1/33) passing" + "; task-passing-to-retain2sampler4ypu: " + str(task4retain2sampler['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['YPU'] = retain2sampler4ypu()                                                               # 
         
            message2print = "{(Step Y2/33) retain" + "; ypu-sampler-retain-by-retain2sampler4ypu to: " + str(sampler4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'YZ-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-retain2sampler4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'ZPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step Z/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Z1/33) passing" + "; task-passing-to-retain2sampler4zpu: " + str(task4retain2sampler['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            sampler4xi ['ZPU'] = retain2sampler4zpu()                                                               # 
         
            message2print = "{(Step Z2/33) retain" + "; zpu-sampler-retain-by-retain2sampler4zpu to: " + str(sampler4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'ZZ-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-retain2sampler4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; sampler4xi-returning-by-retain2sampler4xi: " + str(sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    if debug is True:
        print('(Step 33/33) of retain2sampler4xi - RETURNING SAMPLER2D4XI:  ', sampler4xi) 
    
    return sampler4xi
    
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2samplerinfo4xi" usage = "
#
#   print('(Step 14C/700) OF SAMPLER2D4XI5TEST - TRYING TO VERIFY XI KNOWLEDGEBASE ', time4xi())  
#   try:                               
#       task4getinfo2sampler = {}
#       task4getinfo2sampler ['APU'] = {}
#       task4getinfo2sampler ['APU'] ['CALLBACK'] = 0
#       task4getinfo2sampler ['GPU'] = {}
#       task4getinfo2sampler ['GPU'] ['CALLBACK'] = 0
#       task4getinfo2sampler ['XPU'] = {}
#       task4getinfo2sampler ['XPU'] ['CALLBACK'] = 0          
#       task4getinfo2sampler ['ZPU'] = {}
#       task4getinfo2sampler ['ZPU'] ['CALLBACK'] = 0    
#                          
#       response4getinfo2Dsampler = get2samplerinfo4xi (task4getinfo2sampler)                                                                                             
#       keys2response = response4getinfo2Dsampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4getinfo2Dsampler[key2response])
#           # APU  :  {'CALLBACK': <function trace2sampler4apu at 0x0000000004484C48>}
#           # GPU  :  {'CALLBACK': <function trace2sampler4gpu at 0x00000000049F1D48>}
#           # XPU  :  {'CALLBACK': <function trace2sampler4xpu at 0x0000000005693948>}
#           # ZPU  :  {'CALLBACK': <function trace2sampler4zpu at 0x00000000059090C8>}
#   except:
#       print('(Step 14Z3/700) OF SAMPLER2D4XI5TEST *** FAILED TO VERIFY XI KNOWLEDGEBASE ', time4xi()) 
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2samplerinfo4xi(task4supportedsamplerformats2xi=None):

    '''
    gets sampler4xi
    '''
    
    global sampler4xi
    global info2sampler4xi
    
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "get2samplerinfo4xi"
    method2print = "get2samplerinfo4xi"

    message2print = "{(Step 0A/33) started" + "; get2samplerinfo4xi-started: " + str(get2samplerinfo4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <function get2samplerinfo4xi at 0x0000000003A9E9C8>                                                              
    
    message2print = "{(Step 0A/33) passed" + "; task4supportedsamplerformats2xi-passed-to-get2samplerinfo4xi: " + str(task4supportedsamplerformats2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    if task4supportedsamplerformats2xi is None:
        task4supportedsamplerformats2xi = {}
        
    keys2supportedsamplerformats = task4supportedsamplerformats2xi.keys()
    if debug is True:
        print('(Step 0A/33) of get2samplerinfo4xi - keys2supportedsamplerformats:  ', keys2supportedsamplerformats)    
        # dict_keys(['GPU', 'ZPU', 'PPU', 'APU'])

        print('(step 0a/33) of get2samplerinfo4xi - passed-to-get2samplerinfo4xi task4supportedsamplerformats2xi:  ', task4supportedsamplerformats2xi)   
        # {'GPU': {'DOMAIN': 'ALL'}, 'ZPU': {'DOMAIN': 'ALL'}, 'PPU': {'DOMAIN': 'ALL'}, 'APU': {'DOMAIN': 'ALL'}}

    
    
    if sampler4xi is None:
        # -------------------------------------------------------------------------------------
        # TRY TO CREATE           
        # -------------------------------------------------------------------------------------           
        sampler4xi = create2sampler4xi()
        
        message2print = "{(Step 1B/33) initialized" + "; sampler4xi-initialized-by-get2samplerinfo to: " + str(sampler4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
    else:
        # -------------------------------------------------------------------------------------
        # USE           
        # -------------------------------------------------------------------------------------         
        info2return = {} 
        
          
        if 'APU' in keys2supportedsamplerformats:
            try:
                info2return['APU'] = get2samplerinfo4apu()
                message2print = "{(Step 1C1/33) got" + "; apusampler-got-by-get2samplerinfo: " + str(info2return['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of get2samplerinfo4xi - info2return:  ', info2return) 
                    # 
            except:
                pass     
        if 'BPU' in keys2supportedsamplerformats:
            try:
                info2return['BPU'] = get2samplerinfo4bpu()
                message2print = "{(Step 1C1/33) got" + "; bpusampler-got-by-get2samplerinfo: " + str(info2return['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'CPU' in keys2supportedsamplerformats:
            try:
                info2return['CPU'] = get2samplerinfo4cpu()
                message2print = "{(Step 1C1/33) got" + "; cpusampler-got-by-get2samplerinfo: " + str(info2return['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'DPU' in keys2supportedsamplerformats:
            try:
                info2return['DPU'] = get2samplerinfo4dpu()
                message2print = "{(Step 1C1/33) got" + "; dpusampler-got-by-get2samplerinfo: " + str(info2return['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'EPU' in keys2supportedsamplerformats:
            try:
                info2return['EPU'] = get2samplerinfo4epu()
                message2print = "{(Step 1C1/33) got" + "; epusampler-got-by-get2samplerinfo: " + str(info2return['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'FPU' in keys2supportedsamplerformats:
            try:
                info2return['FPU'] = get2samplerinfo4fpu()
                message2print = "{(Step 1C1/33) got" + "; fpusampler-got-by-get2samplerinfo: " + str(info2return['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'GPU' in keys2supportedsamplerformats:
            try:
                info2return['GPU'] = get2samplerinfo4gpu()
                message2print = "{(Step 1C1/33) got" + "; gpusampler-got-by-get2samplerinfo: " + str(info2return['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'HPU' in keys2supportedsamplerformats:
            try:
                info2return['HPU'] = get2samplerinfo4hpu()
                message2print = "{(Step 1C1/33) got" + "; hpusampler-got-by-get2samplerinfo: " + str(info2return['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #             
            except:
                pass
        if 'IPU' in keys2supportedsamplerformats:    
            try:
                info2return['IPU'] = get2samplerinfo4ipu()
                message2print = "{(Step 1C1/33) got" + "; ipusampler-got-by-get2samplerinfo: " + str(info2return['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'JPU' in keys2supportedsamplerformats:                     
            try:
                info2return['JPU'] = get2samplerinfo4jpu()
                message2print = "{(Step 1C1/33) got" + "; jpusampler-got-by-get2samplerinfo: " + str(info2return['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'KPU' in keys2supportedsamplerformats:                     
            try:
                info2return['KPU'] = get2samplerinfo4kpu()
                message2print = "{(Step 1C1/33) got" + "; kpusampler-got-by-get2samplerinfo: " + str(info2return['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'LPU' in keys2supportedsamplerformats:                     
            try:
                info2return['LPU'] = get2samplerinfo4lpu()
                message2print = "{(Step 1C1/33) got" + "; lpusampler-got-by-get2samplerinfo: " + str(info2return['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'MPU' in keys2supportedsamplerformats:                     
            try:
                info2return['MPU'] = get2samplerinfo4mpu()
                message2print = "{(Step 1C1/33) got" + "; mpusampler-got-by-get2samplerinfo: " + str(info2return['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'NPU' in keys2supportedsamplerformats:                     
            try:
                info2return['NPU'] = get2samplerinfo4npu()
                message2print = "{(Step 1C1/33) got" + "; npusampler-got-by-get2samplerinfo: " + str(info2return['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'OPU' in keys2supportedsamplerformats:                    
            try:
                info2return['OPU'] = get2samplerinfo4opu()
                message2print = "{(Step 1C1/33) got" + "; opusampler-got-by-get2samplerinfo: " + str(info2return['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'PPU' in keys2supportedsamplerformats:                     
            try:
                info2return['PPU'] = get2samplerinfo4ppu()
                message2print = "{(Step 1C1/33) got" + "; ppusampler-got-by-get2samplerinfo: " + str(info2return['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'QPU' in keys2supportedsamplerformats:                     
            try:
                info2return['QPU'] = get2samplerinfo4qpu()
                message2print = "{(Step 1C1/33) got" + "; qpusampler-got-by-get2samplerinfo: " + str(info2return['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'RPU' in keys2supportedsamplerformats:                     
            try:
                info2return['RPU'] = get2samplerinfo4rpu()
                message2print = "{(Step 1C1/33) got" + "; rpusampler-got-by-get2samplerinfo: " + str(info2return['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'SPU' in keys2supportedsamplerformats:                     
            try:
                info2return['SPU'] = get2samplerinfo4spu()
                message2print = "{(Step 1C1/33) got" + "; spusampler-got-by-get2samplerinfo: " + str(info2return['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'TPU' in keys2supportedsamplerformats:                     
            try:
                info2return['TPU'] = get2samplerinfo4tpu()
                message2print = "{(Step 1C1/33) got" + "; tpusampler-got-by-get2samplerinfo: " + str(info2return['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'UPU' in keys2supportedsamplerformats:                     
            try:
                info2return['UPU'] = get2samplerinfo4upu()
                message2print = "{(Step 1C1/33) got" + "; upusampler-got-by-get2samplerinfo: " + str(info2return['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'VPU' in keys2supportedsamplerformats:                    
            try:
                info2return['VPU'] = get2samplerinfo4vpu()
                message2print = "{(Step 1C1/33) got" + "; vpusampler-got-by-get2samplerinfo: " + str(info2return['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'WPU' in keys2supportedsamplerformats:                     
            try:
                info2return['WPU'] = get2samplerinfo4wpu()
                message2print = "{(Step 1C1/33) got" + "; wpusampler-got-by-get2samplerinfo: " + str(info2return['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'XPU' in keys2supportedsamplerformats:                     
            try:
                info2return['XPU'] = get2samplerinfo4xpu()
                message2print = "{(Step 1C1/33) got" + "; xpusampler-got-by-get2samplerinfo: " + str(info2return['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'YPU' in keys2supportedsamplerformats:                     
            try:
                info2return['YPU'] = get2samplerinfo4ypu()
                message2print = "{(Step 1C1/33) got" + "; ypusampler-got-by-get2samplerinfo: " + str(info2return['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'ZPU' in keys2supportedsamplerformats:                     
            try:
                info2return['ZPU'] = get2samplerinfo4zpu()
                message2print = "{(Step 1C1/33) got" + "; zpusampler-got-by-get2samplerinfo: " + str(info2return['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
                     
            
    message2print = "{(Step 33/33) returning" + "; info2return-returning-by-get2samplerinfo: " + str(info2return) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 


    if debug is True:
        print('(Step 33/33) of get2samplerinfo4xi - RETURNING INFO2RETURN:  ', info2return)  
        # 

    return info2return
            
#</function4xi> 
                                               
# =================================================================================================
#<class4xi class = "Sampler4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for XI sampler" usage = "OpenCL XI sampler"
#>

# =================================================================================================
class Sampler4Xi(object): 
    ''' 
    Sampler4Xi offers  methods for XI sampler
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2xi = cpu_corecount4xi()
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'create2sampler',                    # ACK 5.31   p76    
            'copy2sampler',                      # ACK 5.31   p88
            'copy2samplertobuffer',              # ACK 5.3.4  p90
            'copy2buffertosampler',              # ACK 5.3.4  p92
            'read2sampler',                      # ACK 5.3.3  p84
            'write2sampler',                     # ACK 5.3.3  p84            
            'map2sampler',                       # ACK 5.3.5  p94            
            'get2samplerinfo',                   # ACK 5.3.6  p97
            'get2supportedsamplerformats',       # ACK 5.3.2  p82 
            'retain2sampler',                    # ACK 5.4.1  p99 
            'release2sampler',                   # ACK 5.4.1  p99
            'trace2sampler',                     # ACK 
            'set2samplercallback',               # ACK 
            'set2sampler',                       # ACK                
            'wait2sampler',                      # ACK 
            'sense',                           # ACK 
            'reason',                          # ACK 
            'ace')                             # ACK         
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Sampler4Xi" usage = "
    #   print('(Step 105A/700) OF SAMPLER2D4XI5TEST - CREATING SAMPLER4XI OBJECT ', time4xi())     
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                        
    #       # ---------------------------------------------------------------------------------------------        
    #       samplerobject2xi = Sampler4Xi()
    #       print('(Step 105B/700) OF SAMPLER2D4XI5TEST - CREATED SAMPLER4XI OBJECT: ', samplerobject2xi)                                  
    #       # <sampler4xi.Sampler4Xi object at 0x00000000048AAB38>
    #   except:
    #       print('(Step 105Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO CREATE SAMPLER4XI OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4samplercreate2xi = None):
        '''
        _init__ method initializes Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Sampler4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-Sampler4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 23:41:37 09/06/11 Pacific Daylight Time 

        message2print = "{(Step 1B/33) borning" + "; sampler4xi-of-Sampler4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-sampler4xi-of-Sampler4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2xi-sharing-by-sampler4xi-of-Sampler4Xi: " + str(Sampler4Xi.classvariable2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4             
                                
        message2print = "{(Step 1E/33) passed" + "; task4samplercreate2xi-passed-to-init-of-Sampler4Xi: " + str(task4samplercreate2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                            
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4samplercreate2xi-passing-to-create2sampler4xi-by-init-of-Sampler4Xi: " + str(task4samplercreate2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
        
        sampler2xi = create2sampler4xi(task4samplercreate2xi)
        
        message2print = "{(Step 2B/33) performed" + "; create2sampler4xi-performed-by-init-of-Sampler4Xi: " + str(create2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2sampler4xi at 0x0000000003A9E7C8>
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; sampler4xi-of-Sampler4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # { Sampler4Xi : __init__ ; (Step 3A/33) activated; sampler4xi-of-Sampler4Xi-activated: ; time: 00:14:05 09/07/11 Pacific Daylight Time} 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-sampler4xi-of-Sampler4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'> 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2xi-shared-by-sampler4xi-of-Sampler4Xi: " + str(Sampler4Xi.classvariable2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4           
       
        message2print = "{(Step 3D/33) returning" + "; init-of-Sampler4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 00:14:05 09/07/11 Pacific Daylight Time
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2sampler-of-Sampler4Xi" usage = "
    #    print('(Step 123A/700) OF SAMPLER2D4XI5TEST - TRYING TO CREATE 2D SAMPLER for XI ', time4xi()) 
    # 
    #    try:
    #        xi2xi = Sampler4Xi()                            
    #        
    #        task4create2sampler = {} 
    #        for key2pu in keys2pu:
    #            task4create2sampler [key2pu]  = {}
    #                        
    #        response4create2Dsampler = xi2xi.create2sampler(task4create2sampler)                                  
    #        
    #        keys2response = response4create2Dsampler.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4create2Dsampler[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO CREATE 2D SAMPLER for XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2sampler(self, task4sampler2create = None):
        '''
        create2sampler method creates 2D sampler objects of Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Sampler4Xi"
        method2print = "create2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; create2sampler-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 00:14:05 09/07/11 Pacific Daylight Time 
            
        message2print = "{(Step 1B/33) passed" + "; task4sampler2create-passed-to-create-of-Sampler4Xi: " + str(task4sampler2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4sampler2create-passing-to-create2sampler4xi-by-create2sampler-of-Sampler4Xi: " + str(task4sampler2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # None      
  
        sampler2xi = create2sampler4xi(task4sampler2create)

        message2print = "{(Step 2B/33) performed" + "; create2sampler4xi-performed-by-create2sampler-of-Sampler4Xi: " + str(create2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2sampler4xi at 0x00000000039DF7C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; sampler2xi-returning-by-create2sampler-of-Sampler4Xi: " + str(sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return sampler2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2sampler-of-Sampler4Xi" usage = "
    # 
    #    response4set2Dsampler = {} 
    #    print('(Step 114A/700) OF SAMPLER2D4XI5TEST - TRYING TO SET 2D SAMPLER4XI ', time4xi())   
    #    try:                               
    #        response4set2Dsampler = samplerobject2xi.set2sampler(task4set2sampler)                                                                                                         
    #                                                                                      
    #        print('(Step 114B/700) OF SAMPLER2D4XI5TEST - SET 2D SAMPLER4XI ', time4xi())
    #        keys2response = response4set2Dsampler.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4set2Dsampler[key2response])
    #            # APU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
    #            # ....
    #            # ZPU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
    #            
    #        print('(Step 114B/700) OF SAMPLER2D4XI5TEST - SET 2D SAMPLER4XI ', time4xi())
    #        # 06:50:19 11/05/11 Pacific Daylight Time
    #             
    #    except:
    #        print('(Step 114Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO SET 2D SAMPLER4XI *** ', time4xi()) 
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2sampler(self, task4set2sampler = None):
        '''
        sets 2D sampler XI objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Sampler4Xi"
        method2print = "set2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; set2sampler-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2sampler-passed-to-set2sampler-of-Sampler4Xi: " + str(task4set2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2sampler-passing-to-set2sampler4xi-by-set2sampler-of-Sampler4Xi: " + str(task4set2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 

        sampler2xi = set2sampler4xi(task4set2sampler)

        message2print = "{(Step 2B/33) performed" + "; set2sampler4xi-performed-by-set2sampler-of-Sampler4Xi: " + str(set2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function set2sampler4xi at 0x0000000003AB36C8> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; sampler2xi-returning-by-set2sampler-of-Sampler4Xi: " + str(sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return sampler2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2samplerinfo-of-Sampler4Xi" usage = "
    #   
    #    print('(Step 106A1/700) OF SAMPLER2D4XI5TEST - TRYING TO GET 2D SAMPLER INFO WITH METHOD ', time4xi())    
    #    try: 
    #        task4getinfo2sampler = {}
    #        for key2pu in keys2pu:
    #            if KB2CC [key2pu] == 'ACK':
    #                task4getinfo2sampler [key2pu]  = {}
    #                task4getinfo2sampler [key2pu] ['WIDTH']  = 0
    #                task4getinfo2sampler [key2pu] ['HEIGHT']  = 0 
    #               
    #        response4get2samplerinfo = samplerobject2xi.get2samplerinfo(task4getinfo2sampler)                                 
    #                                               
    #        keys2response = response4get2samplerinfo.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4get2samplerinfo[key2response])
    #            # APU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #            # GPU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #            # ZPU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #    except:
    #        print('(Step 106Z1/700) OF SAMPLER2D4XI5TEST *** FAILED TO GET 2D SAMPLER INFO WITH METHOD ', time4xi())    
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2samplerinfo(self, task4samplerinfo2xi=None):
        '''
        get2samplerinfo method gets 2D objects of Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Sampler4Xi"
        method2print = "get2samplerinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2samplerinfo-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        sampler2xi = get2samplerinfo4xi(task4samplerinfo2xi)
        
        message2print = "{(Step 2A/33) returning" + "; sampler2xi-returning-by-get2samplerinfo-of-Sampler4Xi: " + str(sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        return sampler2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2sampler-of-Sampler4Xi" usage = "
    #
    #    print('(Step 133A/700) OF SAMPLER2D4XI5TEST - TRYING TO RELEASE 2D SAMPLERS OF XI DEVICE ', time4xi())    
    #    # 
    #    try: 
    #        task4release = {} 
    #        for key2pu in keys2pu:
    #            task4release [key2pu]  = {}
    #                
    #        response4release = xi2xi.release2sampler(task4release)
    #        
    #        key2response = response4release.keys()
    #        for key2response in keys2response:
    #            print(key2response, ' : ', response4release [key2response] )
    #            #    
    #    except:
    #        print('(Step 133Z1/700) OF SAMPLER2D4XI5TEST *** FAILED TO RELEASE SAMPLERS OF XI DEVICE ', time4xi()) 
    #     
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2sampler(self, task4release2sampler = None):
        '''
        releases Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Sampler4Xi"
        method2print = "release2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; release2sampler-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2sampler-passed-to-release2sampler-of-Sampler4Xi: " + str(task4release2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2sampler-passing-to-release2sampler4xi-by-release2sampler-of-Sampler4Xi: " + str(task4release2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        sampler2xi = release2sampler4xi(task4release2sampler)

        message2print = "{(Step 2B/33) performed" + "; release2sampler4xi-performed-by-release2sampler-of-Sampler4Xi: " + str(release2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; sampler2xi-returning-by-release2sampler-of-Sampler4Xi: " + str(sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                          
                
        return sampler2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2sampler-of-Sampler4Xi" usage = "
    #
    #    print('(Step 134A/700) OF SAMPLER2D4XI5TEST - TRYING TO RETAIN 2D SAMPLER OF XI DEVICE ', time4xi())   
    #    try:
    #        task4retain2sampler = {} 
    #        for key2pu in keys2pu:
    #            task4retain2sampler [key2pu]  = {}
    #            task4retain2sampler [key2pu] ['COUNT2REFERENCE'] = 1 
    #    
    #            response4retain2Dsampler = xi2xi.retain2sampler(task4retain2sampler)                                                                                                 
    #                                    
    #            keys2response = response4retain2Dsampler.keys()
    #            for key2response in keys2response:
    #                print(key2response, ' : ', response4retain2Dsampler[key2response])
    #                #
    #    except:
    #        print('(Step 134Z1/700) OF SAMPLER2D4XI5TEST *** FAILED TO RETAIN 2D SAMPLER OF XI DEVICE ', time4xi())
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2sampler(self, task4retain2sampler = None):
        '''
        retains Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Sampler4Xi"
        method2print = "retain2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; retain2sampler-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 00:14:05 09/07/11 Pacific Daylight Time 
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2sampler-of-Sampler4Xi: " + str(task4retain2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2sampler4xi-by-retain-of-Sampler4Xi: " + str(task4retain2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        sampler2xi = retain2sampler4xi(task4retain2sampler)

        message2print = "{(Step 2B/33) performed" + "; retain2sampler4xi-performed-by-retain2sampler-of-Sampler4Xi: " + str(retain2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function retain2sampler4xi at 0x00000000039DF948>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; sampler2xi-returning-by-retain2sampler-of-Sampler4Xi: " + str(sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                         
                
        return sampler2xi
                                                           
    #</methodize4xi>   

                  
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2sampler-of-Sampler4Xi" usage = "
    #
    #    print('(Step 125A/25) OF SAMPLER2D4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
    #    try:                               
    #        task4trace2sampler  = {}
    #        for key2pu in keys2pu:
    #            task4trace2sampler[key2pu]  = {}
    #            
    #        response4trace2sampler = xi2xi.trace2sampler(task4trace2sampler) 
    #        
    #        key2response = response4trace2sampler.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4trace2sampler[key2response] )
    #            # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4apu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4apu', 'METHOD': 'trace2sampler4apu'}
    #            # BPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4bpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4bpu', 'METHOD': 'trace2sampler4bpu'}
    #            # CPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4cpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4cpu', 'METHOD': 'trace2sampler4cpu'}
    #            # DPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}
    #            # EPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4epu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4epu', 'METHOD': 'trace2sampler4epu'}
    #            # FPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4fpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4fpu', 'METHOD': 'trace2sampler4fpu'}
    #            # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4gpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4gpu', 'METHOD': 'trace2sampler4gpu'}
    #            # HPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4hpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4hpu', 'METHOD': 'trace2sampler4hpu'}
    #            # IPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ipu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4ipu', 'METHOD': 'trace2sampler4ipu'}
    #            # JPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4jpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4jpu', 'METHOD': 'trace2sampler4jpu'}
    #            # KPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4kpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4kpu', 'METHOD': 'trace2sampler4kpu'}
    #            # LPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4lpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4lpu', 'METHOD': 'trace2sampler4lpu'}
    #            # MPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4mpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4mpu', 'METHOD': 'trace2sampler4mpu'}
    #            # NPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4npu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4npu', 'METHOD': 'trace2sampler4npu'}
    #            # OPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4opu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4opu', 'METHOD': 'trace2sampler4opu'}
    #            # PPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ppu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4ppu', 'METHOD': 'trace2sampler4ppu'}
    #            # QPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4qpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4qpu', 'METHOD': 'trace2sampler4qpu'}
    #            # RPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4rpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4rpu', 'METHOD': 'trace2sampler4rpu'}
    #            # SPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4spu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4spu', 'METHOD': 'trace2sampler4spu'}
    #            # TPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4tpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4tpu', 'METHOD': 'trace2sampler4tpu'}
    #            # UPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}
    #            # VPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4vpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4vpu', 'METHOD': 'trace2sampler4vpu'}
    #            # WPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4wpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4wpu', 'METHOD': 'trace2sampler4wpu'}
    #            # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4xpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4xpu', 'METHOD': 'trace2sampler4xpu'}
    #            # YPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ypu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4ypu', 'METHOD': 'trace2sampler4ypu'}
    #            # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4zpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4zpu', 'METHOD': 'trace2sampler4zpu'}
    #                                                                                                       
    #    except:
    #        print('(Step 125Z/25) OF SAMPLER2D4XI5TEST *** FAILED TO TRACE XI: ', time4xi())       
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2sampler(self, task4trace2sampler = None):
        '''
        traces Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Sampler4Xi"
        method2print = "trace2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; trace2sampler-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2sampler-passed-to-trace-of-Sampler4Xi: " + str(task4trace2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None   
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2sampler-passing-to-trace2sampler4xi-by-trace2sampler-of-Sampler4Xi: " + str(task4trace2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None  
  
        trace2xi = trace2sampler4xi(task4trace2sampler)

        message2print = "{(Step 2B/33) performed" + "; trace2sampler4xi-performed-by-trace2sampler-of-Sampler4Xi: " + str(trace2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2sampler-of-Sampler4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                 
                
        return trace2xi
                                                           
    #</methodize4xi>       


    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2samplercallback-of-Sampler4Xi" usage = "
    # 
    #    print('(Step 124A/700) OF SAMPLER2D4XI5TEST - TRYING TO SET SAMPLER CALLBACK WITH METHOD OF OBJECT XI2XI: ', xi2xi) 
    # 
    #    try:
    #        task4callback2sampler = {} 
    #        for key2pu in keys2pu:
    #            task4callback2sampler [key2pu]  = {}
    #                                         
    #        response4callback = xi2xi.set2samplercallback(task4callback2sampler)                                  
    #        
    #        key2response = response4callback.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4callback [key2response] )
    #            # APU  :  {'CALLBACK': <function trace2sampler4apu at 0x00000000043E2648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # BPU  :  {'CALLBACK': <function trace2sampler4bpu at 0x00000000044C40C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # CPU  :  {'CALLBACK': <function trace2sampler4cpu at 0x0000000004581848>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # DPU  :  {'CALLBACK': <function trace2sampler4dpu at 0x00000000046AD048>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # EPU  :  {'CALLBACK': <function trace2sampler4epu at 0x00000000047667C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # FPU  :  {'CALLBACK': <function trace2sampler4fpu at 0x000000000483AF48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # GPU  :  {'CALLBACK': <function trace2sampler4gpu at 0x0000000004914748>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # HPU  :  {'CALLBACK': <function trace2sampler4hpu at 0x00000000049B0EC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # IPU  :  {'CALLBACK': <function trace2sampler4ipu at 0x0000000004A8F6C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # JPU  :  {'CALLBACK': <function trace2sampler4jpu at 0x0000000004B19E48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # KPU  :  {'CALLBACK': <function trace2sampler4kpu at 0x0000000004C00648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # LPU  :  {'CALLBACK': <function trace2sampler4lpu at 0x0000000004CC4DC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # MPU  :  {'CALLBACK': <function trace2sampler4mpu at 0x0000000004DA55C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # NPU  :  {'CALLBACK': <function trace2sampler4npu at 0x0000000004E47D48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # OPU  :  {'CALLBACK': <function trace2sampler4opu at 0x0000000004F4B548>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # PPU  :  {'CALLBACK': <function trace2sampler4ppu at 0x0000000004FDDCC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # QPU  :  {'CALLBACK': <function trace2sampler4qpu at 0x00000000051034C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # RPU  :  {'CALLBACK': <function trace2sampler4rpu at 0x0000000005248C48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # SPU  :  {'CALLBACK': <function trace2sampler4spu at 0x0000000005337448>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # TPU  :  {'CALLBACK': <function trace2sampler4tpu at 0x00000000053F7BC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # UPU  :  {'CALLBACK': <function trace2sampler4upu at 0x00000000054A23C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # VPU  :  {'CALLBACK': <function trace2sampler4vpu at 0x0000000005537B48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # WPU  :  {'CALLBACK': <function trace2sampler4wpu at 0x00000000056AAAC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # XPU  :  {'CALLBACK': <function trace2sampler4xpu at 0x0000000005628348>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # YPU  :  {'CALLBACK': <function trace2sampler4ypu at 0x00000000057572C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # ZPU  :  {'CALLBACK': <function trace2sampler4zpu at 0x0000000005854A48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #                          
    #    except:
    #        print('(Step 124Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO SET SAMPLER CALLBACK WITH METHOD ***', time4xi())    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2samplercallback(self, task4set2samplercallback = None): 
        '''
        set2samplercallback of Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Sampler4Xi"
        method2print = "set2samplercallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2samplercallback-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2samplercallback-passed-to-set2samplercallback-of-Sampler4Xi: " + str(task4set2samplercallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None    
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2samplercallback-passing-to-set2samplercallback -by-set2samplercallback-of-Sampler4Xi: " + str(task4set2samplercallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
        
        callback2xi4sampler = {} 
        try:
            callback2xi4sampler = set2samplercallback4xi (task4set2samplercallback)

            message2print = "{(Step 2B/33) callback2xi4sampler" + "; callback2xi4sampler-set-by-set2samplercallback-of-Sampler4Xi to: " + str(callback2xi4sampler) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # 
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2xi4sampler-failed-by-set2samplercallback-of-Sampler4Xi: " + str(callback2xi4sampler) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2xi4sampler-returning-by-set2samplercallback-of-Sampler4Xi: " + str(callback2xi4sampler) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                                             
        return callback2xi4sampler
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Sampler4Xi" usage = "
    #
    #    print('(Step 170A/700) OF SAMPLER2D4XI5TEST - SENSING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4sense = xi2xi.sense()
    #         
    #         print(response4sense)
    #         # {'classvariable2xi-of-Sampler4Xi': 4, 'object': <sampler4xi.Sampler4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 170Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO SENSE ', time4xi())      
    #  
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Sampler4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Sampler4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; Sampler4Xi-sensing-by-sense-of-Sampler4Xi: " + str(Sampler4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'sampler4xi.Sampler4Xi'>         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-Sampler4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object': <sampler4xi.Sampler4Xi object at 0x0000000004188400>}   
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2xi-of-Sampler4Xi'] = Sampler4Xi.classvariable2xi
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-Sampler4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; Sampler4Xi-sensed-by-sense-of-Sampler4Xi: " + str(Sampler4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # <class 'sampler4xi.Sampler4Xi'>
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-Sampler4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Sampler4Xi" usage = "
    # 
    #    print('(Step 171A/700) OF SAMPLER2D4XI5TEST - REASONING ', time4xi())  
    #    # 
    #    try:
    #                
    #        response4reason = xi2xi.reason()
    #        
    #        print(response4reason)
    #        # {'object-reason-object4xi': <sampler4xi.Sampler4Xi object at 0x0000000006018278>, 'time-reason-of-Sampler4Xi': '09:46:11 11/05/11 Pacific Daylight Time'}         
    # 
    #     except:
    #         print('(Step 171Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO REASON ', time4xi())  
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Sampler4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Sampler4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 01:02:22 09/07/11 Pacific Daylight Time 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; Sampler4Xi-reasoning-by-reason-of-Sampler4Xi: " + str(Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <class 'sampler4xi.Sampler4Xi'>  
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Sampler4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object-reason-object4xi': <sampler4xi.Sampler4Xi object at 0x0000000004188400>}      
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Sampler4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Sampler4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; Sampler4Xi-reasoned-by-reason-of-Sampler4Xi: " + str(Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # <class 'sampler4xi.Sampler4Xi'>
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Sampler4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #            
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Sampler4Xi" usage = "
    # 
    #    print('(Step 172A/700) OF SAMPLER2D4XI5TEST - ACING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4ace = xi2xi.ace()
    # 
    #         print(response4ace)
    #         # {'cores-of-Sampler4Xi': 4, 'object8xi': <sampler4xi.Sampler4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 172Z/700) OF SAMPLER2D4XI5TEST *** FAILED TO ACE ', time4xi())                                     
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Sampler4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Sampler4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; Sampler4Xi-acing-by-ace-of-Sampler4Xi: " + str(Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'sampler4xi.Sampler4Xi'>           
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Sampler4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object8xi': <sampler4xi.Sampler4Xi object at 0x0000000004188400>}   


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-Sampler4Xi'] = Sampler4Xi.classvariable2xi
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Sampler4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; Sampler4Xi-aced-by-ace-of-Sampler4Xi: " + str(Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'sampler4xi.Sampler4Xi'>  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Sampler4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   sampler4xi5test.txt
#   sense-sampler4xi5test.xml
#   reason-sampler4xi5test.xml
#   ace-sampler4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of sampler4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
